"use strict";

var scene = require("./scene");
var group = require("./group");
var timer = require("./timer");
var room = require("./room");
var generic = require("./generic_device");

var devices = {};
devices[scene.type] = scene;
devices[group.type] = group;
devices[timer.type] = timer;
devices[room.type] = room;
devices["gateway"] = generic;
devices["shutter"] = generic;
devices["jalousie"] = generic;
devices["marquee"] = generic;
devices["dimmer"] = generic;
devices["night-switch"] = generic;
devices["twilight-switch"] = generic;
devices["heating"] = generic;
devices["cooling"] = generic;
devices["day-switch"] = generic;

var funcCreate = function(device) {
    var dev = devices[device.type];
    
    if(dev != undefined) {
        return dev.create(device);
    } else {
        return undefined;
    }
}

var funcCheck = function(device) {
	var err = undefined;
	var dev = devices[device.type];
	
	if(dev != undefined) {
		err = dev.check(device);
	} else {
		err = 'Unknown device type "' + device.type + '".';
	}
	return err;
}

var funcDelete = function(id) {
	return "delete " + id + ".*\n";
}

module.exports = {
    create: funcCreate,
    check: funcCheck,
    del: funcDelete
}
