#! /usr/bin/perl -w

# Aufrufbeispiele
# mit ntp: setclock.pl  12.07.2013 11:20:18 Europe/Berlin ntp
# ohne ntp: setclock.pl 12.07.2013 11:20:18 Europe/Berlin

use strict;

my $num_args = $#ARGV + 1;
my $ntp;
my $timezone;
my @date;
my @time;


print "$ARGV[0], $ARGV[1], $num_args\n";

if ($num_args==2) {
	$timezone = $ARGV[0];
	$ntp = $ARGV[1];
}
else {
	@date = split(/\./, $ARGV[0]);
	@time = split(/:/, $ARGV[1]);
	$timezone = $ARGV[2];
	$ntp = $ARGV[3];
	print "$ARGV[2], $ARGV[3]\n";
}


# Zeitzone setzen
qx(/bin/cp /usr/share/zoneinfo/$timezone /etc/localtime);
my $ec = $?;
if ($ec!=0) {
	exit 1;
}

open(TZFILE, '>/etc/timezone');
print TZFILE $timezone;
print TZFILE "\n";
close TZFILE;

$ec = $?;
if ($ec!=0) {
	exit 2;
}

if ($ntp) {
	open(NTPSTART, '>/tmp/ntpstart.sh');
	print NTPSTART "/etc/init.d/ntp start\n";
	close(NTPSTART);

	qx(/usr/bin/at now -f /tmp/ntpstart.sh);
	qx(/usr/sbin/update-rc.d ntp enable 2>&1 >/dev/null);
}
else {
	open(NTPSTOP, '>/tmp/ntpstop.sh');
	print NTPSTOP "/etc/init.d/ntp stop\n";
	close(NTPSTOP);

	qx(/usr/bin/at now -f /tmp/ntpstop.sh);
	qx(/usr/sbin/update-rc.d -f ntp disable 2>&1 >/dev/null);
}

if (@date) {
	# Zeit setzen
	my $setdate =$date[1].$date[0].$time[0].$time[1].$date[2].".".$time[2];
	my $retval = qx(/bin/date $setdate 2>&1);
	$ec = $?;
	if ($ec!=0) {
		exit 3;
	}
	$retval = qx(/sbin/hwclock --systohc --utc 2>&1);
	$ec = $?;
	if ($ec!=0) {
		exit 4;
	}
}


exit 0;
