var fs = require('fs');

var data = {};
var callback = undefined;

var funcGetSettings = function(ids) {
	if(ids == undefined) {
		return data;
	} else {
		result = {};
		for(idx in ids) {
			result[ids[idx]] = data[ids[idx]];
		}
		return result;
	}
}

var funcGetId = function() {
	if(data['id'] == undefined) {
		data['id'] = Math.floor(Math.random()*16777215).toString(16);
	}
	save();
	return data['id'];
}

var funcPut = function(key, value) {
    data[key] = value;
    save();
    
    if(callback != undefined) {
        callback(key);
    }
}

var funcDelete = function(key) {
    if(callback != undefined) {
        callback(key, data[key]);
    }
    data[key] = undefined;
    save();
}

var funcOnChange = function(cb) {
	callback = cb;
}

function save() {
	fs.writeFile('/opt/chs/settings.json', JSON.stringify(data), function(err) {
    	if(err) {
        	console.log(err);
    	} else {
        	console.log("The file was saved!");
    	}
	});
}

var funcImportBackup = function(d) {
    data = d;
    save();
}


module.exports = function() {
	fs.readFile('/opt/chs/settings.json', 'utf8', function (err,file) {
		if (err) {
                    console.log(err)
                    data = {};
  		} else {
                    try {
                        data = JSON.parse(file);
                    } catch(err) {
                        data = {};
                    }
                }
	});

  return {
    getSettings: funcGetSettings,
    del: funcDelete,
    put: funcPut,
    getId: funcGetId,
    importBackup: funcImportBackup,
    onChange: funcOnChange
    /*add: funcAdd,
    edit: funcEdit,
    state: funcState*/
  }
}
