"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var angular_l10n_1 = require("angular-l10n");
var chs_service_1 = require("./chs.service");
var auth_service_1 = require("./auth.service");
var settings_service_1 = require("./settings/settings.service");
require("bootstrap");
var moment = require("moment");
var AppComponent = (function () {
    function AppComponent(locale, translation, _chsService, _authService, _settingsService, _router) {
        this.locale = locale;
        this.translation = translation;
        this._chsService = _chsService;
        this._authService = _authService;
        this._settingsService = _settingsService;
        this._router = _router;
        this._stickNA = false;
        this.title = "commeo Home Server";
        this.version = { version: "", server: "", update: false };
        var curLang = this.locale.getCurrentLanguage();
        var lang = this._settingsService.getLanguage(curLang);
        if (!lang) {
            lang = this._settingsService.getBrowserLanguage();
        }
        if (lang) {
            this.locale.setCurrentLanguage(lang.iso);
        }
        /*
        this.Translation.useLocalStorage();
        this.Translation.addLanguages(["de", "en", "fr", "nl", "po", "cz"]);
        this.Translation.definePreferredLocale("en", "EN");
        this.Translation.definePreferredCurrency("EUR");
        this.Translation.setCurrentLocale("en", "EN");
        this.translation.translationProvider("./resources/Translation-");
        this.translation.updateTranslation();*/
        moment.locale("de");
    }
    AppComponent.prototype.selectLocale = function (language, country, currency) {
        this.locale.setCurrentLanguage(language);
        this.locale.setCurrentCurrency(currency);
    };
    AppComponent.prototype.getVersion = function () {
        var _this = this;
        this._chsService.getVersion().subscribe(function (ver) { return _this.version = ver; }, function (err) { return _this.errMsg = err; });
    };
    AppComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (!this._chsService.GotVersionInfo)
            this.getVersion();
        else
            this.version = this._chsService.VersionInfo;
        this._navMain = jQuery(this._elNavMain.nativeElement);
        this._chsService.onError.subscribe(function (res) { _this.onChsServiceError(res); });
        this._chsService.getGateway().subscribe(function (gw) { _this._stickNA = (gw.state === "na"); });
    };
    AppComponent.prototype.onChsServiceError = function (res) {
        if (res.status === 0) {
            this._chsService.showMessageBox(this.translation.translate("SERVERNOTREACHABLE"));
        }
        else {
            this._chsService.showMessageBox(this.translation.translate("SERVERERROR") + ": (" + res.status + ") " + res.statusText);
        }
    };
    AppComponent.prototype.onLogout = function () {
        this._authService.logout();
        this._navMain.collapse("hide");
        this._router.navigate(["/favorites"]);
    };
    AppComponent.prototype.onMenuClick = function (event) {
        this._navMain.collapse("hide");
    };
    return AppComponent;
}());
__decorate([
    core_1.ViewChild("navMain"),
    __metadata("design:type", core_1.ElementRef)
], AppComponent.prototype, "_elNavMain", void 0);
AppComponent = __decorate([
    core_1.Component({
        moduleId: module.id,
        selector: "commeo-app",
        templateUrl: "app.component.html"
    }),
    __metadata("design:paramtypes", [angular_l10n_1.LocaleService, angular_l10n_1.TranslationService,
        chs_service_1.ChsService, auth_service_1.AuthService, settings_service_1.SettingsService,
        router_1.Router])
], AppComponent);
exports.AppComponent = AppComponent;
//# sourceMappingURL=app.component.js.map