"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var platform_browser_1 = require("@angular/platform-browser");
var forms_1 = require("@angular/forms");
var http_1 = require("@angular/http");
var angular_l10n_1 = require("angular-l10n");
var drive_module_1 = require("./drive/drive.module");
var devices_module_1 = require("./devices/devices.module");
var groups_module_1 = require("./groups/groups.module");
var rooms_module_1 = require("./rooms/rooms.module");
var scenes_module_1 = require("./scenes/scenes.module");
var update_module_1 = require("./update/update.module");
var settings_module_1 = require("./settings/settings.module");
var app_routing_1 = require("./app.routing");
var chs_service_1 = require("./chs.service");
var auth_guard_service_1 = require("./auth-guard.service");
var auth_service_1 = require("./auth.service");
var translation_service_1 = require("./translation.service");
var settings_service_1 = require("./settings/settings.service");
var app_component_1 = require("./app.component");
/**
 * Advanced initialization.
 *
 * With these settings, translation file will be loaded before the app.
 */
var LocalizationConfig = (function () {
    function LocalizationConfig(locale, translation, settings) {
        this.locale = locale;
        this.translation = translation;
        this.settings = settings;
    }
    LocalizationConfig.prototype.load = function () {
        var _this = this;
        var languages = ["de", "en", "fr", "nl", "pl", "cs"];
        var startLang = this.settings.getBrowserLanguage();
        if (languages.findIndex(function (lang) { return startLang.iso === lang; }) === -1) {
            startLang = this.settings.LANGUAGES[1];
        }
        this.locale.addConfiguration()
            .useLocalStorage()
            .addLanguages(languages)
            .defineDefaultLocale(startLang.iso, startLang.country)
            .defineCurrency("EUR");
        this.locale.init();
        //this.locale.setDefaultLocale(startLang.iso, startLang.country);
        this.translation.addConfiguration().addProvider("./resources/locale_");
        this.translation.init();
        var promise = new Promise(function (resolve) {
            _this.translation.translationChanged.subscribe(function () {
                resolve(true);
            });
        });
        return promise;
    };
    return LocalizationConfig;
}());
LocalizationConfig = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [angular_l10n_1.LocaleService, angular_l10n_1.TranslationService, settings_service_1.SettingsService])
], LocalizationConfig);
exports.LocalizationConfig = LocalizationConfig;
/**
 * Aot compilation requires a reference to an exported function.
 */
function initLocalization(localizationConfig) {
    return function () { return localizationConfig.load(); };
}
exports.initLocalization = initLocalization;
var AppModule = (function () {
    function AppModule() {
    }
    return AppModule;
}());
AppModule = __decorate([
    core_1.NgModule({
        imports: [
            angular_l10n_1.TranslationModule.forRoot(),
            platform_browser_1.BrowserModule, forms_1.FormsModule, http_1.HttpModule, drive_module_1.DriveModule,
            devices_module_1.DevicesModule, groups_module_1.GroupsModule, rooms_module_1.RoomsModule, scenes_module_1.ScenesModule, update_module_1.UpdateModule, settings_module_1.SettingsModule,
            app_routing_1.routing
        ],
        declarations: [
            app_component_1.AppComponent
        ],
        providers: [
            LocalizationConfig,
            {
                provide: core_1.APP_INITIALIZER,
                useFactory: initLocalization,
                deps: [LocalizationConfig],
                multi: true
            },
            chs_service_1.ChsService, auth_service_1.AuthService, translation_service_1.TranslateService, auth_guard_service_1.AuthGuard, app_routing_1.appRoutingProviders
        ],
        bootstrap: [app_component_1.AppComponent]
    })
], AppModule);
exports.AppModule = AppModule;
//# sourceMappingURL=app.module.js.map