"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var router_1 = require("@angular/router");
var settings_component_1 = require("./settings/settings.component");
var devices_component_1 = require("./devices/devices.component");
var teachin_component_1 = require("./devices/teachin.component");
var rooms_component_1 = require("./rooms/rooms.component");
var roomassign_component_1 = require("./rooms/roomassign.component");
var groupmembers_component_1 = require("./groups/groupmembers.component");
var groups_component_1 = require("./groups/groups.component");
var update_component_1 = require("./update/update.component");
var favorites_component_1 = require("./drive/favorites.component");
var groupsdrive_component_1 = require("./drive/groupsdrive.component");
var roomsdrive_component_1 = require("./drive/roomsdrive.component");
var scenesdrive_component_1 = require("./drive/scenesdrive.component");
var login_component_1 = require("./shared/login.component");
var auth_guard_service_1 = require("./auth-guard.service");
var appRoutes = [
    { path: '', redirectTo: '/favorites', pathMatch: 'full' },
    { path: 'favorites', component: favorites_component_1.FavoritesComponent },
    { path: 'login', component: login_component_1.LoginComponent },
    { path: "groups", component: groupsdrive_component_1.GroupsDriveComponent },
    { path: "scenes", component: scenesdrive_component_1.ScenesDriveComponent },
    { path: "rooms", component: roomsdrive_component_1.RoomsDriveComponent },
    { path: "cfg/groups", component: groups_component_1.GroupsComponent, canActivate: [auth_guard_service_1.AuthGuard] },
    { path: "cfg/groupmembers/:id", component: groupmembers_component_1.GroupmembersComponent, canActivate: [auth_guard_service_1.AuthGuard] },
    { path: "cfg/devices", component: devices_component_1.DevicesComponent, canActivate: [auth_guard_service_1.AuthGuard] },
    { path: "cfg/teachin", component: teachin_component_1.TeachInComponent, canActivate: [auth_guard_service_1.AuthGuard] },
    { path: "cfg/rooms", component: rooms_component_1.RoomsComponent, canActivate: [auth_guard_service_1.AuthGuard] },
    { path: "cfg/roomassign", component: roomassign_component_1.RoomAssignComponent, canActivate: [auth_guard_service_1.AuthGuard] },
    { path: "cfg/settings", component: settings_component_1.SettingsComponent, canActivate: [auth_guard_service_1.AuthGuard] },
    { path: "cfg/update", component: update_component_1.UpdateComponent, canActivate: [auth_guard_service_1.AuthGuard] }
];
exports.appRoutingProviders = [];
exports.routing = router_1.RouterModule.forRoot(appRoutes, { useHash: true });
//# sourceMappingURL=app.routing.js.map