import { ModuleWithProviders }  from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import {SettingsComponent} from './settings/settings.component';
import {DevicesComponent} from './devices/devices.component';
import {TeachInComponent} from './devices/teachin.component';
import {RoomsComponent} from './rooms/rooms.component';
import {RoomAssignComponent} from './rooms/roomassign.component';
import { GroupmembersComponent } from './groups/groupmembers.component';
import { GroupsComponent }       from './groups/groups.component';
import { UpdateComponent }       from './update/update.component';
import { FavoritesComponent } from './drive/favorites.component';
import { GroupsDriveComponent } from './drive/groupsdrive.component';
import { RoomsDriveComponent } from './drive/roomsdrive.component';
import { ScenesDriveComponent } from './drive/scenesdrive.component';
import { LoginComponent } from './shared/login.component';
import {  AuthGuard } from './auth-guard.service';

const appRoutes: Routes = [
	{	path: '', redirectTo: '/favorites', pathMatch: 'full'	},
	{	path: 'favorites', component: FavoritesComponent	},
	{	path: 'login', component: LoginComponent	},
	{ path: "groups", component: GroupsDriveComponent },
	{ path: "scenes", component: ScenesDriveComponent },
	{ path: "rooms", component: RoomsDriveComponent },
	{ path: "cfg/groups", component: GroupsComponent, canActivate: [AuthGuard] },
	{ path: "cfg/groupmembers/:id", component: GroupmembersComponent, canActivate: [AuthGuard] },
	{ path: "cfg/devices", component: DevicesComponent, canActivate: [AuthGuard] },
	{ path: "cfg/teachin", component: TeachInComponent, canActivate: [AuthGuard] },
	{ path: "cfg/rooms", component: RoomsComponent, canActivate: [AuthGuard] },
	{ path: "cfg/roomassign", component: RoomAssignComponent, canActivate: [AuthGuard] },
	{ path: "cfg/settings", component: SettingsComponent, canActivate: [AuthGuard] },
	{ path: "cfg/update", component: UpdateComponent, canActivate: [AuthGuard] }
];

export const appRoutingProviders: any[] = [

];

export const routing: ModuleWithProviders = RouterModule.forRoot(appRoutes, { useHash: true });