"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var chs_service_1 = require("./chs.service");
var md5_1 = require("./md5");
var AuthService = AuthService_1 = (function () {
    function AuthService(_chsService) {
        var _this = this;
        this._chsService = _chsService;
        if (!this.storedHash() || !this.storedHash2()) {
            this._chsService.getSettings().subscribe(function () {
                var mac = _this._chsService.getStoredSetting("mac");
                var adminMd5 = _this._chsService.getStoredSetting("Admin");
                if (!adminMd5) {
                    adminMd5 = "";
                }
                _this.storeHash(adminMd5);
                if (mac) {
                    _this.storeHash2(md5_1.md5(mac));
                }
                if (adminMd5 === "") {
                    _this.login("");
                }
            });
            /*
            this._chsService.getSetting<string>("Admin").subscribe(md5 => {
              if (md5 == null) md5="";
              this.storeHash(md5);
              if (md5=="")
                this.login("");
            },
              err => { },
              () => { });
              */
        }
    }
    AuthService.prototype.login = function (pwHash) {
        var strHash = this.storedHash();
        if (strHash === "" || pwHash === strHash) {
            sessionStorage.setItem(AuthService_1._loggedIn, "true");
            sessionStorage.setItem(AuthService_1._sessionName, Date.now().toString());
            return true;
        }
        strHash = this.storedHash2();
        if (strHash === "" || pwHash === strHash) {
            sessionStorage.setItem(AuthService_1._loggedIn, "true");
            sessionStorage.setItem(AuthService_1._sessionName, Date.now().toString());
            return true;
        }
        return false;
    };
    AuthService.prototype.storeHash = function (hash) {
        sessionStorage.setItem(AuthService_1._storedHash, hash);
    };
    AuthService.prototype.storeHash2 = function (hash) {
        sessionStorage.setItem(AuthService_1._storedHash2, hash);
    };
    AuthService.prototype.storedHash = function () {
        return sessionStorage.getItem(AuthService_1._storedHash);
    };
    AuthService.prototype.storedHash2 = function () {
        return sessionStorage.getItem(AuthService_1._storedHash2);
    };
    AuthService.prototype.logout = function () {
        sessionStorage.removeItem(AuthService_1._sessionName);
        sessionStorage.removeItem(AuthService_1._loggedIn);
    };
    AuthService.prototype.canLogout = function () {
        var strHash = this.storedHash();
        if (!strHash || strHash == "")
            return false;
        var strLoggedIn = sessionStorage.getItem(AuthService_1._loggedIn);
        return (strLoggedIn === "true");
    };
    AuthService.prototype.checkLogin = function () {
        var strHash = this.storedHash();
        if (!strHash || strHash == "")
            return true;
        var strLoggedIn = sessionStorage.getItem(AuthService_1._loggedIn);
        if (strLoggedIn !== "true")
            return false;
        var strLastTime = sessionStorage.getItem(AuthService_1._sessionName);
        if (strHash && !strLastTime)
            return false;
        var dtLast = parseInt(strLastTime);
        var dtNow = Date.now();
        var diff = 0;
        if (typeof (dtLast) === "number")
            diff = dtNow - dtLast;
        if (diff > 900000)
            return false;
        sessionStorage.setItem(AuthService_1._sessionName, Date.now().toString());
        return true;
    };
    return AuthService;
}());
AuthService._sessionName = "commeoWebAppAdmin";
AuthService._storedHash = "commeoWebAppHash";
AuthService._storedHash2 = "commeoWebAppHash2";
AuthService._loggedIn = "commeoWebAppLoggedIn";
AuthService = AuthService_1 = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [chs_service_1.ChsService])
], AuthService);
exports.AuthService = AuthService;
var AuthService_1;
//# sourceMappingURL=auth.service.js.map