import { Injectable } from "@angular/core";
import { ChsService } from "./chs.service";
import { md5 } from "./md5";

@Injectable()
export class AuthService {
  private static _sessionName = "commeoWebAppAdmin";
  private static _storedHash = "commeoWebAppHash";
  private static _storedHash2 = "commeoWebAppHash2";
  private static _loggedIn = "commeoWebAppLoggedIn";

  private _pw: string;
  // store the URL so we can redirect after logging in
  redirectUrl: string;
  constructor(private _chsService: ChsService) {
    if (!this.storedHash() || !this.storedHash2()) {
      this._chsService.getSettings().subscribe(() => {
        let mac: string = this._chsService.getStoredSetting("mac");
        let adminMd5: string = this._chsService.getStoredSetting("Admin");
        if (!adminMd5) { adminMd5=""; }
        this.storeHash(adminMd5);
        if (mac) {
          this.storeHash2(md5(mac));
        }
        if (adminMd5 === "") {
          this.login("");
        }
      });
      /*
      this._chsService.getSetting<string>("Admin").subscribe(md5 => {
        if (md5 == null) md5="";
        this.storeHash(md5);
        if (md5=="")
          this.login("");
      },
        err => { },
        () => { });
        */
    }
  }
  login(pwHash: string): boolean {
    let strHash: string = this.storedHash();
    if (strHash==="" || pwHash === strHash) {
      sessionStorage.setItem(AuthService._loggedIn, "true");
      sessionStorage.setItem(AuthService._sessionName, Date.now().toString());
      return true;
    }

    strHash = this.storedHash2();
    if (strHash==="" || pwHash === strHash) {
      sessionStorage.setItem(AuthService._loggedIn, "true");
      sessionStorage.setItem(AuthService._sessionName, Date.now().toString());
      return true;
    }

    return false;
  }

  storeHash(hash: string): void {
    sessionStorage.setItem(AuthService._storedHash, hash);
  }

  storeHash2(hash: string) {
    sessionStorage.setItem(AuthService._storedHash2, hash);
  }

  storedHash(): string {
    return sessionStorage.getItem(AuthService._storedHash);
  }

  storedHash2(): string {
    return sessionStorage.getItem(AuthService._storedHash2);
  }

  logout() {
    sessionStorage.removeItem(AuthService._sessionName);
    sessionStorage.removeItem(AuthService._loggedIn);
  }

  canLogout(): boolean {
    let strHash = this.storedHash();
    if (!strHash || strHash=="") return false;
    let strLoggedIn = sessionStorage.getItem(AuthService._loggedIn);
    return (strLoggedIn === "true");
  }

  checkLogin(): boolean {
    let strHash = this.storedHash();
    if (!strHash || strHash=="") return true;
    let strLoggedIn = sessionStorage.getItem(AuthService._loggedIn);
    if (strLoggedIn !== "true") return false;
    let strLastTime = sessionStorage.getItem(AuthService._sessionName);
    if (strHash && !strLastTime) return false;

    let dtLast = parseInt(strLastTime);
    let dtNow = Date.now();

    let diff=0;

    if (typeof(dtLast)==="number")
      diff=dtNow-dtLast;

    if (diff>900000) // nach 15 Minuten abgelaufen
      return false;

    sessionStorage.setItem(AuthService._sessionName, Date.now().toString());
    return true;
  }
}
