"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
var Observable_1 = require("rxjs/Observable");
var utils_1 = require("./utils");
//import {AsyncSubject} from 'rxjs/AsyncSubject';
//import 'rxjs/add/operator/merge';
//import 'rxjs/add/operator/concatAll';
require("rxjs/add/operator/catch");
require("rxjs/add/operator/map");
require("rxjs/add/operator/delay");
require("rxjs/add/operator/concat");
require("rxjs/add/operator/do");
require("rxjs/add/operator/repeat");
require("rxjs/add/operator/merge");
require("rxjs/add/operator/publish");
require("rxjs/add/operator/retry");
require("rxjs/observable/range");
var ErrorObservable_1 = require("rxjs/observable/ErrorObservable");
require("rxjs/observable/throw");
var DevState = (function () {
    function DevState() {
    }
    DevState.equals = function (d1, d2) {
        return d1.state === d2.state && d1.driving === d2.driving && d1.auto === d2.auto;
    };
    return DevState;
}());
exports.DevState = DevState;
var ChsService = ChsService_1 = (function () {
    function ChsService(http) {
        var _this = this;
        this.http = http;
        //private _url = 'http://debian8.fritz.box:8080/';
        //private _url = "http://192.168.188.20:80/";
        //private _url = 'http://127.0.0.1:8080/';
        //private _url='http://localhost:8080/';
        this._url = location.origin + "/";
        this.onError = new core_1.EventEmitter();
        this.stateChanged = new core_1.EventEmitter();
        this.onGotSettings = new core_1.EventEmitter();
        this.onPairingFinished = new core_1.EventEmitter();
        this.stateChangingSubscriptionCount = 0;
        this._mapDevs = new Map();
        this._mapRealDevs = new Map();
        this._mapGroups = new Map();
        this._mapScenes = new Map();
        this._mapTimers = new Map();
        this._mapRooms = new Map();
        this._mapSettings = new Map();
        this._setFavorites = new Set();
        this._gateway = { type: "gateway", id: "" };
        this.stateChanging = this.http.get(this._url + "devices?filter=real")
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); })
            .map(function (res) { return _this.mapToChanges(res); })
            .delay(1000).repeat();
        //.do(sc => { console.debug("State changes: " + sc ? sc.length.toString() : "undef"); }).repeat();
    }
    Object.defineProperty(ChsService.prototype, "Url", {
        get: function () {
            return this._url;
        },
        enumerable: true,
        configurable: true
    });
    ChsService.prototype.mapToChanges = function (res) {
        var service = this;
        var devs = res.json();
        var changes = [];
        devs.forEach(function (dev) {
            if (dev.type !== "group" && dev.type !== "scene" && dev.type !== "timer" &&
                dev.type !== "room" && dev.type !== "gateway" && dev.readings) {
                ChsService_1.convertReadingsToMap(dev);
                var readings = dev.readings;
                var moving = readings.get("moving");
                var oldDev = service._mapRealDevs.get(dev.id);
                var oldDevState = { state: null, driving: null, auto: null };
                var oldReadings = oldDev.readings;
                var oldMoving = "";
                if (oldReadings) {
                    oldMoving = oldReadings.get("moving");
                    oldDevState.driving = !(!oldMoving || oldMoving === "stopped");
                    oldDevState.auto = oldReadings.get("automatic");
                    oldDevState.state = oldReadings.get("current");
                }
                var sc = {
                    devId: dev.id,
                    newState: { state: readings.get("current"), driving: !(!moving || moving === "stopped"), auto: readings.get("automatic") },
                    oldState: oldDevState
                };
                if (!DevState.equals(sc.oldState, sc.newState)) {
                    changes.push(sc);
                    oldDev.readings = readings;
                    service._mapRealDevs.set(oldDev.id, oldDev);
                }
            }
        });
        if (changes.length > 0) {
            service.stateChanged.emit(changes);
        }
        return changes;
    };
    Object.defineProperty(ChsService.prototype, "Gateway", {
        get: function () {
            return this._gateway;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChsService.prototype, "Groups", {
        get: function () {
            return this._mapGroups;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChsService.prototype, "Scenes", {
        get: function () {
            return this._mapScenes;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChsService.prototype, "Timers", {
        get: function () {
            return this._mapTimers;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChsService.prototype, "Rooms", {
        get: function () {
            return this._mapRooms;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChsService.prototype, "RealDevs", {
        get: function () {
            return this._mapRealDevs;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChsService.prototype, "Devices", {
        get: function () {
            return this._mapDevs;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChsService.prototype, "VersionInfo", {
        get: function () {
            var versionInfo = JSON.parse(sessionStorage.getItem(ChsService_1.VERSIONSTORE));
            return versionInfo;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChsService.prototype, "GotVersionInfo", {
        get: function () {
            return sessionStorage.getItem(ChsService_1.VERSIONSTORE) !== undefined;
        },
        enumerable: true,
        configurable: true
    });
    ChsService.convertReadingsToMap = function (dev) {
        if (!dev.readings) {
            return;
        }
        var readings = dev.readings;
        dev.readings = new Map();
        Object.keys(readings).forEach(function (key) {
            dev.readings.set(key, readings[key]);
        });
    };
    ChsService.prototype.fillMap = function (devs) {
        var _this = this;
        this._mapDevs.clear();
        this._mapRealDevs.clear();
        this._mapGroups.clear();
        this._mapScenes.clear();
        devs.forEach(function (dev) {
            if (dev.type === "group") {
                if (!dev.members)
                    dev.members = [];
                _this._mapGroups.set(dev.id, dev);
            }
            else if (dev.type === "scene") {
                if (!dev.members)
                    dev.members = [];
                _this._mapScenes.set(dev.id, dev);
            }
            else if (dev.type === "timer")
                _this._mapTimers.set(dev.id, dev);
            else if (dev.type === "room")
                _this._mapRooms.set(dev.id, dev);
            else if (dev.type === "gateway") {
                _this._gateway = dev;
            }
            else {
                ChsService_1.convertReadingsToMap(dev);
                dev.group = "nogroup";
                _this._mapRealDevs.set(dev.id, dev);
            }
            _this._mapDevs.set(dev.id, dev);
        });
        /*	this._mapRealDevs.forEach(dev => {
                dev.group = "nogroup";
                this._mapGroups.forEach(group => {
                    (<string[]>group.members).forEach(member => {
                        if (dev.id == member) { dev.group = group.id; }
                    })
                })
                this._mapScenes.forEach(scene => {
                    (<Member[]>scene.members).forEach(member => {
                        if (dev.id == member.id) { dev.scene = scene.id; }
                    })
                })
            });*/
    };
    ChsService.prototype.delGroup = function (id) {
        if (this._mapGroups.delete(id)) {
            this._mapDevs.delete(id);
            this._mapRealDevs.forEach(function (dev) {
                if (dev.group === id)
                    dev.group = "nogroup";
            });
        }
    };
    ChsService.prototype.delScene = function (id) {
        if (this._mapScenes.delete(id)) {
            this._mapDevs.delete(id);
            this._mapRealDevs.forEach(function (dev) {
                if (dev.device === id)
                    dev.device = "noscene";
            });
        }
    };
    ChsService.prototype.delTimer = function (id) {
        this._mapTimers.delete(id);
        this._mapDevs.delete(id);
    };
    ChsService.prototype.delDevice = function (id) {
        if (this._mapDevs.delete(id)) {
            // TODO: Gerät aus Gruppen und Szenen löschen ???
        }
    };
    ChsService.prototype.showMessageBox = function (strMsg) {
        this.msgboxtext = strMsg;
    };
    ChsService.prototype.getVersion = function () {
        var _this = this;
        return this.http.get(this._url + "info").catch(function (err, caught) { return _this.handleError(err, caught, _this); })
            .map(function (res) { return res.json(); })
            .do(function (data) { sessionStorage.setItem(ChsService_1.VERSIONSTORE, JSON.stringify(data)); });
    };
    ChsService.prototype.getVersionRaw = function () {
        return this.http.get(this._url + "info")
            .map(function (res) { return res.json(); })
            .catch(function (err, caught) { return err; });
    };
    ChsService.prototype.pollServerVersion = function (cb) {
        var obVersion = this.http.get(this._url + "info");
        var hotRepeat = new Observable_1.Observable().delay(10000).repeat().publish();
        //return obVersion.delay(10000).takeWhile((val, index) => !val.version);
        var safeRepeat = hotRepeat.concat(obVersion).retry();
        safeRepeat.subscribe();
        hotRepeat.connect();
    };
    ChsService.prototype.getDevices = function (filter) {
        var _this = this;
        var url = this._url + "devices";
        if (filter) {
            url += "?filter=" + filter;
        }
        var obDevices = this.http.get(url).map(function (res) { var devs = res.json(); return devs; })
            .do(function (devs) { _this.fillMap(devs); });
        var obSettings = this.http.get(this._url + "settings")
            .map(function (res) { var settings = res.json(); return settings; })
            .do(function (settings) { _this.storeSettings(settings); });
        return obSettings.merge(obDevices)
            .do(function (x) { }, function (err) { }, function () { _this.applySettingsToDevs(); })
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.getGateway = function () {
        var _this = this;
        var obDevices = this.http.get(this._url + "devices?filter=gateway")
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); })
            .map(function (res) {
            try {
                var devs = res.json();
                _this._gateway = devs[0];
                return devs[0];
            }
            catch (e) {
                return null;
            }
        })
            .do(function (dev) { _this._gateway = dev; });
        return obDevices;
    };
    ChsService.prototype.startGettingStateChange = function () {
        var _this = this;
        return this.http.get(this._url + "devices")
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); })
            .map(function (res) { var devs = res.json(); return devs; })
            .do(function (devs) { _this.fillMap(devs); });
    };
    ChsService.prototype.deleteGroup = function (id) {
        var _this = this;
        return this.http.delete(this._url + "devices/" + id).do(function (data) {
            console.log("deleted group " + id);
            _this.delGroup(id);
        }).catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.deleteScene = function (id) {
        var _this = this;
        return this.http.delete(this._url + "devices/" + id).do(function (data) {
            console.log("deleted scene " + id);
            _this.delScene(id);
        }).catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.deleteTimer = function (id) {
        var _this = this;
        return this.http.delete(this._url + "devices/" + id).do(function (data) {
            console.log("deleted timer " + id);
            _this.delTimer(id);
        }).catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.deleteRoom = function (id) {
        var _this = this;
        var obDel = [this.http.delete(this._url + "devices/" + id).do(function (data) {
                console.log("deleted room " + id);
                _this._mapRooms.delete(id);
                _this._mapDevs.delete(id);
            })];
        this._mapRealDevs.forEach(function (dev) {
            if (dev.room === id) {
                dev.room = null;
                obDel.push(_this.writeDevice(dev));
            }
        });
        return this.mergeResp(obDel);
    };
    ChsService.prototype.deleteDevice = function (id) {
        var _this = this;
        return this.http.delete(this._url + "devices/" + id).do(function (data) {
            console.log("deleted device " + id);
            _this.delDevice(id);
        }).catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.newDevice = function (dev, devCB) {
        var _this = this;
        var body = JSON.stringify(dev);
        var headers = new http_1.Headers({ "Content-Type": "application/json" });
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.post(this._url + "devices", body, options)
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); })
            .map(function (res) {
            var data = res.json();
            dev.id = data.id;
            _this._mapDevs.set(dev.id, dev);
            devCB(dev);
            return dev;
        })
            .do(function (data) { return console.log("NewDevice: " + data); });
    };
    ChsService.prototype.newTimer = function (sceneid) {
        var _this = this;
        var nIdCount = 0;
        var newTimerId = "TIMER.";
        var setIds = new Set(this._mapDevs.keys());
        var setNames = new Set();
        this._mapDevs.forEach(function (dev) {
            setNames.add(dev.name);
        });
        while (setIds.has(newTimerId + nIdCount.toString()))
            ++nIdCount;
        var dev = {
            id: newTimerId + nIdCount.toString(), name: "", device: sceneid, device_state: "", type: "timer",
            days: "1111111", timer_type: "static", time: "12:00", state: "on", favorite: false, sort: utils_1.maxSort(this._mapTimers) + 1
        };
        return this.newDevice(dev, function (d) {
            _this._mapTimers.set(d.id, d);
        });
    };
    ChsService.prototype.newScene = function () {
        var _this = this;
        var nIdCount = 0;
        var newSceneId = "SCENE.";
        var nNameCount = 0;
        var newName = "Neue Szene ";
        var setIds = new Set(this._mapDevs.keys());
        var setNames = new Set();
        this._mapDevs.forEach(function (dev) {
            setNames.add(dev.name);
        });
        while (setIds.has(newSceneId + nIdCount.toString()))
            ++nIdCount;
        while (setNames.has(newName + nNameCount.toString()))
            ++nNameCount;
        var dev = {
            id: newSceneId + nIdCount.toString(), name: newName + nNameCount.toString(), type: "scene",
            members: new Array(), favorite: false, sort: utils_1.maxSort(this._mapScenes) + 1
        };
        return this.newDevice(dev, function (d) {
            _this._mapScenes.set(d.id, d);
        });
    };
    ChsService.prototype.removeFromScene = function (id, sceneid) {
        var _this = this;
        var dev = this._mapRealDevs.get(id);
        if (!dev)
            return;
        var scene = this._mapScenes.get(sceneid);
        if (!scene)
            return;
        scene.members = scene.members.filter(function (value) { return value.id !== id; });
        var headers = new http_1.Headers({ "Content-Type": "application/json" });
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.put(this._url + "devices/" + sceneid, JSON.stringify(scene), options)
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.addToScene = function (id, sceneid, value) {
        var _this = this;
        var dev = this._mapRealDevs.get(id);
        if (!dev)
            return;
        var scene = this._mapScenes.get(sceneid);
        if (!scene)
            return;
        var index = scene.members.findIndex(function (dev) { return dev.id === id; });
        if (index < 0) {
            scene.members.push({ id: id, value: value });
        }
        else {
            scene.members[index].value = value;
        }
        var headers = new http_1.Headers({ "Content-Type": "application/json" });
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.put(this._url + "devices/" + sceneid, JSON.stringify(scene), options)
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.newGroup = function () {
        var _this = this;
        var nIdCount = 0;
        var newGroupId = "GROUP.";
        var nNameCount = 0;
        var newName = "Neue Gruppe ";
        var setIds = new Set(this._mapDevs.keys());
        var setNames = new Set();
        this._mapDevs.forEach(function (dev) {
            setNames.add(dev.name);
        });
        while (setIds.has(newGroupId + nIdCount.toString()))
            ++nIdCount;
        while (setNames.has(newName + nNameCount.toString()))
            ++nNameCount;
        var dev = {
            id: newGroupId + nIdCount.toString(), name: newName + nNameCount.toString(), type: "group",
            members: new Array(), favorite: false, sort: utils_1.maxSort(this._mapGroups) + 1
        };
        return this.newDevice(dev, function (d) {
            _this._mapGroups.set(d.id, d);
        });
    };
    ChsService.prototype.getGroupState = function (id) {
        var group = this._mapGroups.get(id);
        if (group && group.members && group.members.length > 0) {
            var devId = group.members[0];
            var dev = this._mapRealDevs.get(devId);
            if (dev)
                return ChsService_1.getTypeState(dev.type);
        }
        return "";
    };
    ChsService.prototype.getDeviceState = function (id) {
        var dev = this._mapRealDevs.get(id);
        if (dev)
            return ChsService_1.getTypeState(dev.type);
        dev = this._mapGroups.get(id);
        if (dev)
            return this.getGroupState(id);
        dev = this._mapScenes.get(id);
        if (dev)
            return "";
    };
    ChsService.getTypeState = function (devType) {
        if (devType === "dimmer" || devType === "shutter" || devType === "marquee" || devType === "jalousie")
            return "slider";
        else if (devType === "night-switch" || devType === "twighlight-switch" || devType === "day-switch")
            return "onoff";
        else if (devType === "scene")
            return "startstop";
        return "";
    };
    ChsService.prototype.removeFromGroup = function (id, groupid) {
        var _this = this;
        var dev = this._mapRealDevs.get(id);
        if (!dev)
            return;
        var group = this._mapGroups.get(groupid);
        if (!group)
            return;
        group.members = group.members.filter(function (value) { return value !== id; });
        var headers = new http_1.Headers({ "Content-Type": "application/json" });
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.put(this._url + "devices/" + groupid, JSON.stringify(group), options)
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.addToGroup = function (id, groupid) {
        var _this = this;
        var dev = this._mapRealDevs.get(id);
        if (!dev)
            return;
        var group = this._mapGroups.get(groupid);
        if (!group)
            return;
        if (!group.members.find(function (dev) { return dev === id; })) {
            group.members.push(id);
        }
        var headers = new http_1.Headers({ "Content-Type": "application/json" });
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.put(this._url + "devices/" + groupid, JSON.stringify(group), options)
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.changeGroup = function (id, newGroup) {
        var _this = this;
        var headers = new http_1.Headers({ "Content-Type": "application/json" });
        var options = new http_1.RequestOptions({ headers: headers });
        var dev = this._mapRealDevs.get(id);
        if (!dev)
            return;
        var devNewGroup = null;
        if (newGroup !== "nogroup") {
            devNewGroup = this._mapGroups.get(newGroup);
        }
        var devOldGroup = null;
        if (dev.group !== "nogroup") {
            devOldGroup = this._mapGroups.get(dev.group);
        }
        if (devNewGroup)
            devNewGroup.members.push(dev.id);
        if (devOldGroup) {
            var members = devOldGroup.members;
            devOldGroup.members = [];
            members.forEach(function (member) { if (member !== dev.id)
                devOldGroup.members.push(member); });
        }
        if (devOldGroup && devNewGroup) {
            return this.http.put(this._url + "devices/" + devOldGroup.id, JSON.stringify(devOldGroup), options).concat(this.http.put(this._url + "devices/" + devNewGroup.id, JSON.stringify(devNewGroup), options))
                .do(function (data) {
                dev.group = devNewGroup.id;
            })
                .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
        }
        else if (devNewGroup) {
            return this.http.put(this._url + "devices/" + devNewGroup.id, JSON.stringify(devNewGroup), options)
                .do(function (data) {
                dev.group = devNewGroup.id;
            })
                .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
        }
        else {
            return this.http.put(this._url + "devices/" + devOldGroup.id, JSON.stringify(devOldGroup), options).do(function (data) {
                dev.group = "nogroup";
            })
                .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
        }
    };
    ChsService.prototype.writeDevice = function (dev) {
        var _this = this;
        var headers = new http_1.Headers({ "Content-Type": "application/json" });
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.put(this._url + "devices/" + dev.id, JSON.stringify(dev), options)
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
        /* Hat nicht funktioniert: put ohne Body
        var gottenDevice : Device;
        return this.http.get(this._url+"devices/" + dev.id).do(data => { gottenDevice =<Device> data.json(); gottenDevice.name=dev.name; console.log("renamed " + JSON.stringify(gottenDevice)); })
            .concat(this.http.put(this._url+"devices/" + dev.id, JSON.stringify(gottenDevice), options)).catch(this.handleError);*/
    };
    ChsService.prototype.mergeResp = function (ar) {
        if (ar.length === 0)
            return null;
        if (ar.length === 1)
            return ar[0];
        //return Observable.merge(ar);
        /*return Observable.concatAll(ar);*/
        var result = ar[0].merge(ar[1]);
        for (var i = 2; i < ar.length; ++i) {
            result = result.merge(ar[i]);
        }
        return result;
    };
    ChsService.prototype.writeDevices = function (devs) {
        var _this = this;
        if (devs.length === 0)
            return null;
        if (devs.length === 1)
            return this.writeDevice(devs[0]);
        var ar = [];
        devs.forEach(function (dev) {
            ar.push(_this.writeDevice(dev));
        });
        return this.mergeResp(ar);
    };
    ChsService.prototype.beginTeachIn = function () {
        var observableGetState = this.getGateway().map(function (dev) { return dev.state; });
        var observablePair = this.setDevState(this._gateway.id, "pair").map(function (x) { return ""; }).do(function (x) { console.debug("begin pairing"); });
        return observablePair.concat(observableGetState.delay(1000).repeat());
    };
    ChsService.prototype.pollGateway = function () {
        var observableGetState = this.getGateway().map(function (dev) { return dev.state; }); //.do(s => { console.debug('got gateway state ' + s); });
        return observableGetState.delay(1000).repeat();
    };
    ChsService.prototype.setDevState = function (devId, val) {
        var _this = this;
        var headers = new http_1.Headers({ "Content-Type": "application/json" });
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.post(this._url + "devices/" + devId + "/state", JSON.stringify({ "state": val }), options)
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.getCachedDev = function (id) {
        return this._mapDevs.get(id);
    };
    ChsService.prototype.refreshFavoritesSet = function (favs) {
        var _this = this;
        this._setFavorites.clear();
        if (favs != null) {
            favs.forEach(function (fav) { _this._setFavorites.add(fav); });
        }
    };
    ChsService.prototype.getFavorites = function (bFilter) {
        var _this = this;
        var ar;
        ar = JSON.parse(localStorage.getItem(ChsService_1.FAVORITES));
        if (ar == null)
            ar = [];
        if (bFilter) {
            var arnew_1 = ar;
            ar = [];
            ar.forEach(function (fav) {
                if (_this._mapDevs.has(fav))
                    arnew_1.push(fav);
            });
            ar = arnew_1;
        }
        this.refreshFavoritesSet(ar);
        return ar;
    };
    ChsService.prototype.setFavorites = function (favs) {
        localStorage.setItem(ChsService_1.FAVORITES, JSON.stringify(favs));
        this.refreshFavoritesSet(favs);
    };
    ChsService.prototype.setFavorite = function (id, value) {
        if (!value)
            this.removeFavorite(id);
        else
            this.addFavorite(id);
    };
    ChsService.prototype.addFavorite = function (fav) {
        var favs = this.getFavorites(true);
        if (!(favs.indexOf(fav) >= 0)) {
            favs.push(fav);
            this.setFavorites(favs);
        }
    };
    ChsService.prototype.removeFavorite = function (fav) {
        var favs = this.getFavorites(true);
        var newfavs = [];
        favs.forEach(function (elem) {
            if (elem !== fav)
                newfavs.push(elem);
        });
        this.setFavorites(newfavs);
    };
    ChsService.prototype.storeSettings = function (settings) {
        if (settings == null)
            return;
        for (var key in settings) {
            try {
                this._mapSettings.set(key, settings[key]);
            }
            catch (e) {
                /*	if (e instanceof SyntaxError) {
                        console.debug("Setting " + key + " ist kein JSON:" + e.message);
                    }*/
            }
        }
    };
    ChsService.prototype.applySettingsToDevs = function () {
        var _this = this;
        // Favoriten
        this.getFavorites(true);
        this._mapDevs.forEach(function (dev) {
            dev.favorite = _this._setFavorites.has(dev.id);
        });
    };
    ChsService.prototype.getStoredSetting = function (id) {
        return this._mapSettings.get(id);
    };
    ChsService.prototype.getSettings = function () {
        var _this = this;
        return this.http.get(this._url + "settings")
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); })
            .map(function (res) { var settings = res.json(); return settings; })
            .do(function (settings) { _this.storeSettings(settings); _this.onGotSettings.emit(); })
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.getSetting = function (id) {
        var _this = this;
        return this.http.get(this._url + "settings/" + id)
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); })
            .do(function (res) {
            var setting;
            try {
                setting = res.json();
                _this.storeSettings(setting);
            }
            catch (ex) { }
        })
            .map(function (res) {
            var setting = res.json();
            if (setting && setting[id] !== undefined) {
                try {
                    return setting[id];
                }
                catch (e) {
                    return null;
                }
            }
            return null;
        })
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.pollSetting = function (id) {
        var observableGetState = this.getSetting(id);
        return observableGetState.delay(1000).repeat();
    };
    ChsService.prototype.setSetting = function (id, value) {
        var _this = this;
        var headers = new http_1.Headers({ "Content-Type": "application/json" });
        var options = new http_1.RequestOptions({ headers: headers });
        var sett = { key: id, value: value };
        var body = JSON.stringify(sett);
        return this.http.post(this._url + "settings", body, options).do(function () { _this._mapSettings.set(id, value); })
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.deleteSetting = function (id) {
        var _this = this;
        return this.http.delete(this._url + "settings/" + id)
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.renameRoom = function (id, newName) {
        var room = this.Rooms.get(id);
        if (room) {
            room.name = newName;
            this.writeDevice(room).subscribe(function (n) { }, function (err) { }, function () { });
        }
    };
    ChsService.prototype.newRoom = function () {
        var _this = this;
        var nIdCount = 0;
        var newId = "ROOM.";
        var nNameCount = 0;
        var newName = "Neuer Raum ";
        var setIds = new Set(this._mapDevs.keys());
        var setNames = new Set();
        this._mapRooms.forEach(function (dev) {
            setNames.add(dev.name);
        });
        while (setIds.has(newId + nIdCount.toString()))
            ++nIdCount;
        while (setNames.has(newName + nNameCount.toString()))
            ++nNameCount;
        var dev = { id: newId + nIdCount.toString(), name: newName + nNameCount.toString(), type: "room", sort: utils_1.maxSort(this._mapRooms) + 1 };
        return this.newDevice(dev, function (d) {
            _this._mapRooms.set(d.id, d);
        });
    };
    ChsService.prototype.startUpdate = function () {
        var _this = this;
        var body = JSON.stringify({ "update": true });
        var headers = new http_1.Headers({ "Content-Type": "application/json" });
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.post(this._url + "update", body, options)
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.setDateTime = function (st) {
        var _this = this;
        var options = new http_1.RequestOptions({ headers: new http_1.Headers({ "Content-Type": "application/json" }) });
        return this.http.post(this._url + "time", JSON.stringify(st), options)
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); });
    };
    ChsService.prototype.getDateTime = function () {
        var _this = this;
        return this.http.get(this._url + "time")
            .catch(function (err, caught) { return _this.handleError(err, caught, _this); })
            .map(function (res) { return res.json(); });
    };
    ChsService.prototype.getTime = function () {
        var _this = this;
        return this.http.get(this._url + "time").catch(function (err, caught) { return _this.handleError(err, caught, _this); })
            .map(function (res) { return res.json(); });
    };
    ChsService.prototype.subscribeToStateChange = function (callback) {
        var _this = this;
        if (this.stateChangingSubscriptionCount === 0) {
            this.stateChangingSubscription = this.stateChanging.subscribe(function (changes) {
                _this.stateChanged.emit(changes);
            });
        }
        this.stateChangingSubscriptionCount += 1;
        return this.stateChanged.subscribe(function (changes) { if (changes.length > 0)
            callback(changes); });
    };
    ChsService.prototype.unsubscribeFromStateChange = function (sub) {
        sub.unsubscribe();
        if (this.stateChangingSubscriptionCount > 0) {
            this.stateChangingSubscriptionCount -= 1;
            if (this.stateChangingSubscriptionCount === 0 && this.stateChangingSubscription) {
                this.stateChangingSubscription.unsubscribe();
                this.stateChangingSubscription = null;
            }
        }
    };
    ChsService.prototype.handleError = function (error, caught, chs) {
        console.log(error);
        chs.onError.emit(error);
        return new ErrorObservable_1.ErrorObservable(error);
        //return Observable.throw(error);
    };
    return ChsService;
}());
ChsService.FAVORITES = "Favorites";
ChsService.VERSIONSTORE = "ApiVersion";
ChsService = ChsService_1 = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [http_1.Http])
], ChsService);
exports.ChsService = ChsService;
var ChsService_1;
//# sourceMappingURL=chs.service.js.map