export interface Reading {
	key: string;
	value: string;
}

export interface WithId {
	id: string;
}


export interface Member extends WithId {
		value?: string | number;
}


export enum devType { light = 1, switch, outlet, dimmer, shutter, marquee, jalousie, thermostat, window, smoke, scene, group }
export enum timerType { astroSunrise, astroSunset, static, random }


export interface Device extends WithId {
	name?: string;
	type: string;
	room?: string;
	state?: string;
	auto?: boolean;
	readings?: Reading[] | Map<string, string|number|boolean>;
	members?: Member[] | string[];
	newDev?: boolean;
	group?: string;
	device?: string;
	device_state?: string;
	// Scene speichern
	timers?: Device[];
	// Timer
	timer_type?: string;
	time?: string;
	offset?: number;
	days?: string;
	// extra
	favorite?: boolean;
	sort?: number;
	sort_dev?: number;
}
