"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var chs_service_1 = require("../chs.service");
var utils_1 = require("../utils");
var DevicesComponent = (function () {
    function DevicesComponent(el, _chsService, _router) {
        this.el = el;
        this._chsService = _chsService;
        this._router = _router;
        this._devices = [];
        this._stickNA = true;
    }
    DevicesComponent.prototype.initDevices = function () {
        var _this = this;
        this._chsService.getDevices().subscribe(function (x) { }, function (err) { }, function () {
            try {
                _this._stickNA = (_this._chsService.Gateway.state === "na");
                _this._devices = utils_1.sortRealDevs(_this._chsService.RealDevs.values());
            }
            catch (ex) { }
        });
    };
    DevicesComponent.prototype.ngAfterViewInit = function () {
        this.initDevices();
    };
    DevicesComponent.prototype.onSearchDevices = function () {
        this._router.navigate(["cfg/teachin"]);
    };
    DevicesComponent.prototype.onDeviceDelete = function (id) {
        var _this = this;
        this._chsService.deleteDevice(id).subscribe(function () {
            _this._devices = _this._devices.filter(function (d) { return d.id != id; });
        });
    };
    DevicesComponent.prototype.orderChanged = function () {
        var items = jQuery(this.el.nativeElement).find(".panel.panel-default");
        var ar = [];
        for (var index = 0; index < items.length; index++) {
            var element = jQuery(items[index]);
            var dev = this._chsService.RealDevs.get(element.attr("id"));
            dev.sort_dev = index;
            ar.push(dev);
        }
        this._chsService.writeDevices(ar).subscribe(function (next) { }, function (err) { }, function () { });
    };
    return DevicesComponent;
}());
DevicesComponent = __decorate([
    core_1.Component({
        template: "\n\t\t\t<div class='panel panel-primary'>\n\t\t\t\t<div class='panel-heading' translate>DEVS</div>\n\t\t\t\t<jqxSortable id='devicelist' class='panel-body' [handle]='\".handle\"' (onStop)=\"orderChanged()\">\n\t\t\t\t\t<div *ngFor=\"let device of _devices\" class='panel panel-default' id=\"{{device.id}}\">\n\t\t\t\t\t\t<device-editor [dev]=\"device\" (onDeleted)=\"onDeviceDelete($event)\"></device-editor>\n\t\t\t\t\t</div>\n\t\t\t\t</jqxSortable>\n\t\t\t</div>\n\t\t\t<p></p>\n\t\t\t<button type=\"button\" class=\"btn btn-default\" (click)=\"onSearchDevices()\" [disabled]=\"_stickNA\" translate>STARTTEACHIN</button>\n\t\t\t<p></p>\n\t\t\t"
    }),
    __metadata("design:paramtypes", [core_1.ElementRef, chs_service_1.ChsService, router_1.Router])
], DevicesComponent);
exports.DevicesComponent = DevicesComponent;
//# sourceMappingURL=devices.component.js.map