"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var chs_service_1 = require("../chs.service");
var utils_1 = require("../utils");
var TeachInComponent = TeachInComponent_1 = (function () {
    function TeachInComponent(el, _chsService, _router) {
        this.el = el;
        this._chsService = _chsService;
        this._router = _router;
        //private _devicelist: JQuery;
        this._devices = [];
        this._setExistinDevIds = new Set();
        this.bPairing = true;
    }
    TeachInComponent.prototype.initDevices = function () {
        //this._chsService.setSetting(ChsService.DEVORDER, [ "CGW.0", "CGW.1"]).subscribe(() => { console.debug("Setting geschrieben")});
        var _this = this;
        this._chsService.getDevices().subscribe(function (x) { }, function (err) { }, function () {
            try {
                var bScanning = (_this._chsService.Gateway.state === "scan");
                if (!bScanning) {
                    var devs = utils_1.sortRealDevs(_this._chsService.RealDevs.values());
                    if (devs.length > 0) {
                        var nMax = devs[devs.length - 1].sort_dev;
                        if (nMax === undefined) {
                            nMax = 0;
                        }
                        if (nMax < devs.length - 1) {
                            nMax = devs.length;
                        }
                        localStorage.setItem(TeachInComponent_1.MAXSORT, nMax.toString());
                        _this._setExistinDevIds.clear();
                        devs.forEach(function (dev) {
                            _this._setExistinDevIds.add(dev.id);
                        });
                        localStorage.setItem(TeachInComponent_1.SETTING, JSON.stringify(_this._setExistinDevIds));
                    }
                    var subScr_1 = _this._chsService.beginTeachIn().subscribe(function (x) {
                        console.debug("next " + x.toString());
                        if (x === "ready") {
                            _this.fillNewDevices();
                            subScr_1.unsubscribe();
                        }
                    }, function (err) { console.debug("err"); }, function () {
                        console.debug("complete");
                    });
                }
                else {
                    var existingIds = localStorage.getItem(TeachInComponent_1.SETTING);
                    if (existingIds && existingIds.length > 0)
                        _this._setExistinDevIds = JSON.parse(existingIds);
                    _this._subScanning = _this._chsService.pollGateway().subscribe(function (x) {
                        console.debug("next " + x.toString());
                        if (x === "ready") {
                            _this.fillNewDevices();
                            _this._subScanning.unsubscribe();
                        }
                    }, function (err) { console.debug("err"); }, function () {
                        console.debug("complete");
                    });
                }
            }
            catch (ex) {
            }
        });
    };
    TeachInComponent.prototype.fillNewDevices = function () {
        var _this = this;
        this._chsService.getDevices().subscribe(function (x) { }, function (err) { }, function () {
            _this.bPairing = false;
            var nSortDev = 0;
            var strMax = localStorage.getItem(TeachInComponent_1.MAXSORT);
            if (strMax) {
                nSortDev = Number.parseInt(strMax);
            }
            _this._devices = [];
            _this._chsService.RealDevs.forEach(function (dev) {
                if (!_this._setExistinDevIds.has(dev.id)) {
                    dev.sort_dev = (++nSortDev);
                    _this._devices.push(dev);
                }
            });
            /* Keine Geräte schreiben. Sie sind schom im Stick.
            if (this._devices.length>0) {
                this._chsService.writeDevices(this._devices).subscribe();
            }*/
        });
    };
    TeachInComponent.prototype.ngAfterViewInit = function () {
        this.initDevices();
    };
    TeachInComponent.prototype.ngOnDestroy = function () {
        if (this._subScanning) {
            this._subScanning.unsubscribe();
        }
    };
    TeachInComponent.prototype.onBack = function () {
        this._router.navigate(["cfg/devices"]);
    };
    TeachInComponent.prototype.onDeviceDelete = function (id) {
        var _this = this;
        this._chsService.deleteDevice(id).subscribe(function () {
            _this._devices = _this._devices.filter(function (d) { return d.id !== id; });
        });
    };
    return TeachInComponent;
}());
TeachInComponent.SETTING = "teachinOldDevs";
TeachInComponent.MAXSORT = "teachinMaxSort";
TeachInComponent = TeachInComponent_1 = __decorate([
    core_1.Component({
        moduleId: module.id,
        selector: "commeo-devices",
        templateUrl: "teachin.component.html"
    }),
    __metadata("design:paramtypes", [core_1.ElementRef, chs_service_1.ChsService, router_1.Router])
], TeachInComponent);
exports.TeachInComponent = TeachInComponent;
var TeachInComponent_1;
//# sourceMappingURL=teachin.component.js.map