import { Component, OnInit, AfterViewInit, ElementRef, ViewChild } from "@angular/core";
import { ChsService } from "../chs.service";
import { Device } from "../devices/device";

@Component({
	template: `
		<div class='panel panel-primary'>
			<div class='panel-heading' translate>FAVS</div>
			<jqxSortable class='panel-body' [handle]="'.handle'" (onStop)='orderChanged()'>
				<div *ngFor="let device of _devices">
					<device-drive [dev]="device" [sortHandle]='true' [showClose]='true' (onDeleted)='onDeleted($event)'></device-drive>
				</div>
			</jqxSortable>
		</div>
	`
})
export class FavoritesComponent implements OnInit, AfterViewInit {
	private _devices: Device[];


	constructor(private el: ElementRef, private _chsService: ChsService) {

	}

	ngOnInit() {
	}

	ngAfterViewInit() {
		this._chsService.getDevices().subscribe(x => { }, err => { }, () => {
			try {
				var ar: Device[] = [];
				let favs = this._chsService.getFavorites(true);
				favs.forEach(id => {
					let dev = this._chsService.Devices.get(id);
					if (dev)
						ar.push(dev);
					else // Favorit löschen, weil das Gerät nicht existiert
						this._chsService.removeFavorite(id);
				});
				this._devices = ar;
			} catch (ex) {

			}
		});
	}

	private orderChanged() {
		let items = jQuery(this.el.nativeElement).find(".panel.panel-default[id]");
		var ar: string[] = [];

		for (var index = 0; index < items.length; index++) {
			var element = jQuery(items[index]);
			ar.push(element.attr("id"));
		}

		this._chsService.setFavorites(ar);

	}

	private onDeleted(id: string) {
		var ar: Device[] = [];
		this._devices.forEach(dev => {
			if (dev.id !== id) {
				ar.push(dev);
			}
		});
		this._devices = ar;

		this._chsService.removeFavorite(id);
	}

}