"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var chs_service_1 = require("../chs.service");
var utils_1 = require("../utils");
var OneRoomDriveComponent = (function () {
    function OneRoomDriveComponent(_chsService) {
        this._chsService = _chsService;
        this._devs = [];
    }
    OneRoomDriveComponent.prototype.initData = function () {
        var _this = this;
        if (!this.room) {
            return;
        }
        try {
            var ar = [];
            this._chsService.RealDevs.forEach(function (dev) {
                //console.debug("raum " + this.room.id + " gerät." + dev.id + " in raum " + dev.room);
                if (dev.room === _this.room.id) {
                    ar.push(dev);
                }
            });
            this._devs = utils_1.sortDevs(ar.values());
        }
        catch (ex) {
        }
    };
    OneRoomDriveComponent.prototype.ngOnChanges = function (changes) {
        for (var propName in changes) {
            if (propName === "room") {
                /*let prop: SimpleChange = changes[propName];
                let roomNew: any = <Device>prop.currentValue;
                let roomOld: any = <Device>prop.previousValue;
                */
                this.initData();
            }
        }
    };
    return OneRoomDriveComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], OneRoomDriveComponent.prototype, "room", void 0);
OneRoomDriveComponent = __decorate([
    core_1.Component({
        selector: "room-drive",
        template: "\n\t\t<div class='panel panel-primary'>\n\t\t\t<div class='panel-heading'>{{room.name}}</div>\n\t\t\t<div class='panel-body container-fluid'>\n\t\t\t\t<div *ngFor=\"let device of _devs; let idx = index; let lastDev = last\"  class=\"col-md-3\">\n\t\t\t\t\t<device-drive [dev]=\"device\"></device-drive>\t\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\n\t"
    }),
    __metadata("design:paramtypes", [chs_service_1.ChsService])
], OneRoomDriveComponent);
exports.OneRoomDriveComponent = OneRoomDriveComponent;
var RoomsDriveComponent = (function () {
    function RoomsDriveComponent(_chsService) {
        this._chsService = _chsService;
        this._noroomDevs = [];
    }
    RoomsDriveComponent.prototype.ngOnInit = function () {
        var _this = this;
        this._noroomDevs = [];
        this._chsService.getDevices().subscribe(function (x) { }, function (err) { }, function () {
            try {
                _this._rooms = utils_1.sortDevs(_this._chsService.Rooms.values());
                var sortedDevs = utils_1.sortDevs(_this._chsService.RealDevs.values());
                sortedDevs.forEach(function (dev) {
                    if (!dev.room || dev.room.length === 0) {
                        _this._noroomDevs.push(dev);
                    }
                });
            }
            catch (ex) {
            }
        });
    };
    return RoomsDriveComponent;
}());
RoomsDriveComponent = __decorate([
    core_1.Component({
        template: "\n\t\t<div *ngFor=\"let room of _rooms\">\n\t\t\t<room-drive [room]='room'></room-drive>\n\t\t</div>\n\t\t<div class='panel panel-primary'>\n\t\t\t<div class='panel-heading' translate>NOROOMDEVS</div>\n\t\t\t<div class='panel-body container-fluid'>\n\t\t\t\t<div *ngFor=\"let device of _noroomDevs; let idx = index; let lastDev = last\"  class=\"col-md-3\">\n\t\t\t\t\t<device-drive [dev]=\"device\"></device-drive>\t\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\t\t\t\n\t"
    }),
    __metadata("design:paramtypes", [chs_service_1.ChsService])
], RoomsDriveComponent);
exports.RoomsDriveComponent = RoomsDriveComponent;
//# sourceMappingURL=roomsdrive.component.js.map