import { Component, AfterViewInit, ElementRef } from "@angular/core";
import {ChsService} from "../chs.service";
import {Device} from "../devices/device";
import { sortDevs } from "../utils";

@Component({
	template: `
		<div class='panel panel-primary'>
			<div class='panel-heading' translate>SCENES</div>
			<div class='panel-body'>
				<div *ngFor="let device of _devices">
					<device-drive [dev]="device"></device-drive>
				</div>
			</div>
		</div>
	`
})
export class ScenesDriveComponent implements AfterViewInit {
	private _devices: Device[];

	constructor(private el: ElementRef, private _chsService: ChsService) {
	}

	ngAfterViewInit(): void {
		this._chsService.getDevices().subscribe(x=> {}, err => {}, () => {
			try {
				this._devices=sortDevs(this._chsService.Scenes.values());
			} catch (ex) {}
		});
	}
}