"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
var GroupDataAdapter = (function () {
    function GroupDataAdapter(_chsService) {
        this._chsService = _chsService;
        this.source = {
            localData: new Array(),
            dataType: "array",
            dataFields: [
                { name: "id", type: "string" },
                { name: "status", map: "group", type: "string" },
                { name: "text", map: "name", type: "string" },
                { name: "tags", map: "type", type: "string" },
                { name: "resourceId", map: "type", type: "string" },
                { name: "origid", type: "string" },
                { name: "color", type: "string" }
            ]
        };
    }
    GroupDataAdapter.prototype.setDevices = function (filter) {
        var _this = this;
        this.source.localData = [];
        this._chsService.RealDevs.forEach(function (dev) {
            if (!filter || filter === dev.type)
                _this.source.localData.push({ id: dev.id.replace(".", "_"), origid: dev.id, name: dev.name, group: dev.group, type: dev.type, color: utils_1.backcolor });
        });
    };
    GroupDataAdapter.prototype.setDevicesForGroup = function (groupid) {
        var _this = this;
        var members = this._chsService.getCachedDev(groupid).members;
        var sMembers = new Set(members);
        this.source.localData = [];
        this._chsService.RealDevs.forEach(function (dev) {
            var g = "nogroup";
            if (sMembers.has(dev.id))
                g = groupid;
            _this.source.localData.push({ id: dev.id.replace(".", "_"), origid: dev.id, name: dev.name, group: g, type: dev.type, color: utils_1.backcolor });
        });
    };
    GroupDataAdapter.prototype.dataAdapter = function () {
        var da = new $.jqx.dataAdapter(this.source);
        return da;
    };
    GroupDataAdapter.prototype.resources = function () {
        return utils_1.resources;
    };
    return GroupDataAdapter;
}());
exports.GroupDataAdapter = GroupDataAdapter;
//# sourceMappingURL=groupDataAdapter.js.map