import {ChsService} from "../chs.service";
import {resources, backcolor} from "../utils";

export class GroupDataAdapter {
		constructor(private _chsService: ChsService) { }

	private source =
	{
		localData: new Array<any>(),
		dataType: "array",
		dataFields: [
			{ name: "id", type: "string" },
			{ name: "status", map: "group", type: "string" },
			{ name: "text", map: "name", type: "string" },
			{ name: "tags", map: "type", type: "string" },
			{ name: "resourceId", map: "type", type: "string" },
			{ name: "origid", type: "string" },
			{ name: "color", type: "string" }
		]
	};
	
	public setDevices(filter?: string) {
		this.source.localData = [];
		this._chsService.RealDevs.forEach(dev => {
			if (!filter || filter===dev.type)
				this.source.localData.push({ id: dev.id.replace(".", "_"), origid: dev.id, name: dev.name, group: dev.group, type: dev.type, color: backcolor });
		});
	}

	public setDevicesForGroup(groupid: string) {
		let members=<string[]>this._chsService.getCachedDev(groupid).members;
		var sMembers = new Set<string>(members);
		this.source.localData = [];
		this._chsService.RealDevs.forEach(dev => {
			let g="nogroup";
			if (sMembers.has(dev.id))
				g=groupid;
			this.source.localData.push({ id: dev.id.replace(".", "_"), origid: dev.id, name: dev.name, group: g, type: dev.type, color: backcolor });
		});
	}



	public dataAdapter(): any {
		var da: DataAdapter = new $.jqx.dataAdapter(this.source);
		return da;
	}

	public resources() {
		return resources;
	}
}