"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var angular_l10n_1 = require("angular-l10n");
var chs_service_1 = require("../chs.service");
var GroupeditorComponent = (function () {
    function GroupeditorComponent(translation, _chsService, _router) {
        this.translation = translation;
        this._chsService = _chsService;
        this._router = _router;
        this.onDeleted = new core_1.EventEmitter();
        this._edit = false;
        this._sliding = false;
        this._timers = [];
    }
    GroupeditorComponent.prototype.onClose = function () {
        this.onDeleted.emit(this.dev.id);
    };
    GroupeditorComponent.prototype.onEditToggle = function () {
        // wird nicht aufgerufen, wenn der onValueChange-Handler aktiv ist
        if (this._edit) {
            this._edit = false;
            if (this._oldName !== this.dev.name) {
                this._chsService.writeDevice(this.dev).subscribe(function () { });
            }
        }
        else {
            this._edit = true;
            this._oldName = this.dev.name;
            this._input.nativeElement.focus();
        }
    };
    GroupeditorComponent.prototype.onGotoMembers = function () {
        this._router.navigate(["cfg/groupmembers", this._id]);
    };
    GroupeditorComponent.prototype.onTimers = function () {
        this._router.navigate(["cfg/timers", this._id]);
    };
    GroupeditorComponent.prototype.onSliderChange = function (val) {
        if (val.type === "slideStart") {
            this._sliding = true;
            return;
        }
        if (this._sliding && val.type !== "slideEnd") {
            return;
        }
        this._sliding = false;
        //console.debug("slider event " + val.type + ", args type " + val.args.type + " value " + val.args.value);
        var num = Math.round(val.args.value) - 1;
        this.drive("drivePos " + num.toString());
    };
    GroupeditorComponent.prototype.onSwitchChange = function (val) {
        this.drive(val.args.checked ? "on" : "off");
    };
    GroupeditorComponent.prototype.ngOnInit = function () {
        var _this = this;
        this._id = this.dev.id.replace(".", "__");
        this._state = this._chsService.getGroupState(this.dev.id);
        this._timers = [];
        this._chsService.Timers.forEach(function (dev) { if (dev.type === "timer" && dev.device === _this.dev.id) {
            _this._timers.push(dev);
        } });
    };
    GroupeditorComponent.prototype.onFocused = function (event) {
        if (!this._edit) {
            this._oldName = this.dev.name;
            this._edit = true;
        }
    };
    GroupeditorComponent.prototype.onValueChanged = function () {
        if (this._input.nativeElement.value !== this.dev.name) {
            this.dev.name = this._input.nativeElement.value;
        }
        if (this._edit) {
            this.onEditToggle();
        }
    };
    GroupeditorComponent.prototype.onFavChange = function () {
        this.dev.favorite = !this.dev.favorite;
        this._chsService.setFavorite(this.dev.id, this.dev.favorite);
    };
    GroupeditorComponent.prototype.drive = function (cmd) {
        this._chsService.setDevState(this.dev.id, cmd).subscribe(function () { });
    };
    GroupeditorComponent.prototype.onDriveUp = function () {
        this.drive("driveUp");
    };
    GroupeditorComponent.prototype.onDriveDown = function () {
        this.drive("driveDown");
    };
    GroupeditorComponent.prototype.onDriveStop = function () {
        this.drive("stop");
    };
    GroupeditorComponent.prototype.onDriveZP1 = function () {
        this.drive("drivePos1");
    };
    GroupeditorComponent.prototype.onDriveZP2 = function () {
        this.drive("drivePos2");
    };
    return GroupeditorComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], GroupeditorComponent.prototype, "dev", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", Object)
], GroupeditorComponent.prototype, "onDeleted", void 0);
__decorate([
    core_1.ViewChild("nameInput"),
    __metadata("design:type", core_1.ElementRef)
], GroupeditorComponent.prototype, "_input", void 0);
GroupeditorComponent = __decorate([
    core_1.Component({
        moduleId: module.id,
        selector: "group-editor",
        templateUrl: "groupeditor.component.html"
    }),
    __metadata("design:paramtypes", [angular_l10n_1.TranslationService, chs_service_1.ChsService,
        router_1.Router])
], GroupeditorComponent);
exports.GroupeditorComponent = GroupeditorComponent;
//# sourceMappingURL=groupeditor.component.js.map