"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var angular_l10n_1 = require("angular-l10n");
var chs_service_1 = require("../chs.service");
var translation_service_1 = require("../translation.service");
var groupDataAdapter_1 = require("./groupDataAdapter");
var GroupmembersComponent = (function () {
    function GroupmembersComponent(translation, _route, _router, _chsService, _transService) {
        var _this = this;
        this.translation = translation;
        this._route = _route;
        this._router = _router;
        this._chsService = _chsService;
        this._transService = _transService;
        this._visible = true;
        this._evtVisible = new core_1.EventEmitter(true);
        this._columns = [{ text: "NOGROUP", dataField: "nogroup" }, { text: "", dataField: "" }];
        this._template = "\n\t\t\t\t\t<div groups class='jqx-kanban-item' id=''>\n\t\t\t\t\t\t<div groups class='jqx-kanban-item-color-status'></div>\n\t\t\t\t\t\t<div groups style='display: none;' class='jqx-kanban-item-avatar'></div>\n\t\t\t\t\t\t<div groups class='jqx-kanban-item-text'></div>\n\t\t\t\t\t\t<div groups style='display: none' class='jqx-kanban-item-footer'></div>\n\t\t\t\t\t</div>\n\t\t\t\t";
        this._itemRenderer = function (element, item, resource) {
            jQuery(element).find(".jqx-kanban-item-color-status").html("<img class='menu-icon' src='" + resource.image + "' height='16px' /><span style='line-height: 23px; margin-left: 5px; color:white;'>" + resource.name + "</span>");
        };
        this._id = this._route.snapshot.params["id"].replace("__", ".");
        this._evtVisible.subscribe(function (v) { _this.visibleTrick(v); });
    }
    GroupmembersComponent.prototype.visibleTrick = function (v) {
        var g = this._chsService.getCachedDev(this._id);
        this.initData(g);
        this._visible = v;
    };
    GroupmembersComponent.prototype.initData = function (s) {
        if (s == null) {
            return;
        }
        this._group = s;
        var strNoGroup = this.translation.translate("NOGROUP");
        this._columns = [{ text: strNoGroup, dataField: "nogroup" }, { text: this._group.name, dataField: this._group.id }];
        this._da = new groupDataAdapter_1.GroupDataAdapter(this._chsService);
        this._resources = this._da.resources();
        this._da.setDevicesForGroup(this._group.id);
        this._source = this._da.dataAdapter();
    };
    GroupmembersComponent.prototype.ngOnInit = function () {
        var _this = this;
        var s = this._chsService.getCachedDev(this._id);
        if (s) {
            this.initData(s);
        }
        else {
            this._chsService.getDevices().subscribe(function (devs) {
                s = _this._chsService.getCachedDev(_this._id);
                _this.initData(s);
            }, function (error) { }, function () { });
        }
    };
    GroupmembersComponent.prototype.onItemMoved = function (event) {
        var args = event.args;
        if (args.oldColumn.dataField !== args.newColumn.dataField) {
            var itemData_1 = args.itemData;
            var records = this._source.records;
            // Originale Id holen aus DataAdapter
            var origid = "";
            var recordIndex = -1;
            records.forEach(function (item, index) {
                if (item.id === itemData_1.id) {
                    origid = item.origid;
                    recordIndex = index;
                }
            });
            if (args.newColumn.dataField === "nogroup") {
                this._chsService.removeFromGroup(origid, args.oldColumn.dataField).subscribe(function () { });
            }
            else {
                // prüfen, ob das Gerät zu den anderen Geräte der Gruppe passt
                var groupstate = this._chsService.getGroupState(this._group.id);
                var devstate = this._chsService.getDeviceState(origid);
                if (groupstate.length === 0 || groupstate === devstate) {
                    this._chsService.addToGroup(origid, args.newColumn.dataField).subscribe(function () { });
                }
                else {
                    this._visible = false;
                    this._evtVisible.emit(true);
                    /*let opts: any = this._kanban.manageAttributes();
                    this._kanban.destroy();
                    jQuery(this._kanban.elementRef.nativeElement).html("<ng-content></ng-content>");
                    this.initData(this._group);
                    opts.source=this._source;
                    opts.resources=this._resources;
                    opts.columns=this._columns;
                    this._kanban.createComponent();*/
                }
            }
        }
    };
    GroupmembersComponent.prototype.onBack = function () {
        this._router.navigate(["cfg/groups"]);
    };
    return GroupmembersComponent;
}());
GroupmembersComponent = __decorate([
    core_1.Component({
        moduleId: module.id,
        selector: "commeo-groups",
        template: "\n\t\t<div class='panel panel-primary'>\n\t\t\t<div class='panel-heading'><span translate>ASSIGNMEMBERS</span> {{_group?.name}}</div>\n\t\t\t<div class='panel-body'>\n\t\t\t\t<div *ngIf='_group && _visible'>\n\t\t\t\t\t<jqxKanban [width]=\"'100%'\" [itemRenderer]='_itemRenderer'\n\t\t\t\t\t\t[source]='_source' [template]='_template' [resources]='_resources'\n\t\t\t\t\t\t[columns]='_columns' (onItemMoved)='onItemMoved($event)'>\n\t\t\t\t\t</jqxKanban>\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\n\t\t<p></p>\n\t\t<button type=\"button\" class=\"btn btn-default\" (click)=\"onBack()\" translate>BACK</button>\n\t\t<p></p>\n\t"
    }),
    __metadata("design:paramtypes", [angular_l10n_1.TranslationService,
        router_1.ActivatedRoute, router_1.Router,
        chs_service_1.ChsService, translation_service_1.TranslateService])
], GroupmembersComponent);
exports.GroupmembersComponent = GroupmembersComponent;
//# sourceMappingURL=groupmembers.component.js.map