"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var chs_service_1 = require("../chs.service");
var groupDataAdapter_1 = require("./groupDataAdapter");
var utils_1 = require("../utils");
var GroupsComponent = (function () {
    function GroupsComponent(el, _chsService) {
        this.el = el;
        this._chsService = _chsService;
        //private _groups: Device[] = [{ id: 'group.0', name: 'Gruppe 1', type: 'group' }, { id: 'group.1', name: 'Gruppe 2', type: 'group' }];
        this._groups = [];
        this._da = new groupDataAdapter_1.GroupDataAdapter(_chsService);
    }
    GroupsComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this._chsService.getDevices().subscribe(function (devs) {
            _this._da.setDevices();
            try {
                _this._groups = utils_1.sortDevs(_this._chsService.Groups.values());
            }
            catch (ex) { }
        }, function (error) { });
    };
    GroupsComponent.prototype.onNewGroup = function () {
        var _this = this;
        this._chsService.newGroup().subscribe(function (group) {
            _this._groups.push(group);
        });
    };
    GroupsComponent.prototype.onGroupDelete = function (id) {
        var _this = this;
        this._chsService.deleteGroup(id).subscribe(function () {
            _this._groups = _this._groups.filter(function (g) { return g.id != id; });
        });
    };
    GroupsComponent.prototype.orderChanged = function () {
        var items = jQuery(this.el.nativeElement).find(".panel.panel-default[id]");
        var ar = [];
        for (var index = 0; index < items.length; index++) {
            var element = jQuery(items[index]);
            var dev = this._chsService.Groups.get(element.attr("id"));
            dev.sort = index;
            ar.push(dev);
        }
        this._chsService.writeDevices(ar).subscribe(function (next) { }, function (err) { }, function () { });
    };
    return GroupsComponent;
}());
GroupsComponent = __decorate([
    core_1.Component({
        selector: "commeo-groups",
        template: "\n\t\t\t<div class='panel panel-primary'>\n\t\t\t\t<div class='panel-heading' translate>GROUPS</div>\n\t\t\t\t<jqxSortable class='panel-body' [handle]=\"'.handle'\" (onStop)='orderChanged()'>\n\t\t\t\t\t<div *ngFor=\"let group of _groups\">\n\t\t\t\t\t\t<group-editor [dev]=\"group\" (onDeleted)=\"onGroupDelete($event)\"></group-editor>\n\t\t\t\t\t</div>\n\t\t\t\t</jqxSortable>\n\t\t\t</div>\n\t\t\t<p></p>\n\t\t\t<button type=\"button\" class=\"btn btn-default\" (click)=\"onNewGroup()\" translate>NEWGROUP</button>\n\t\t\t<p></p>\n\t\t\t"
    }),
    __metadata("design:paramtypes", [core_1.ElementRef, chs_service_1.ChsService])
], GroupsComponent);
exports.GroupsComponent = GroupsComponent;
//# sourceMappingURL=groups.component.js.map