"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var angular_l10n_1 = require("angular-l10n");
var chs_service_1 = require("../chs.service");
var translation_service_1 = require("../translation.service");
var angular_jqxkanban_1 = require("../jqwidgets-ts/angular_jqxkanban");
var utils_1 = require("../utils");
var utils_2 = require("../utils");
var RoomAssignComponent = (function () {
    function RoomAssignComponent(translation, _route, _router, _chsService, _transService) {
        this.translation = translation;
        this._route = _route;
        this._router = _router;
        this._chsService = _chsService;
        this._transService = _transService;
        this._visible = false;
        this._columnsStart = [{ text: "ohne Raum", dataField: "noroom" }];
        this._columns = this._columnsStart;
        this._resources = utils_1.resources;
        this._onMoved = new core_1.EventEmitter(true);
        this._subscriptionMoved = null;
        this._template = "\n\t\t\t\t\t<div groups class='jqx-kanban-item' id=''>\n\t\t\t\t\t\t<div groups class='jqx-kanban-item-color-status'></div>\n\t\t\t\t\t\t<div groups style='display: none;' class='jqx-kanban-item-avatar'></div>\n\t\t\t\t\t\t<div groups class='jqx-kanban-item-text'></div>\n\t\t\t\t\t\t<div groups style='display: none' class='jqx-kanban-item-footer'></div>\n\t\t\t\t\t</div>\n\t\t\t\t";
        this._source = {
            localData: new Array(),
            dataType: "array",
            dataFields: [
                { name: "id", type: "string" },
                { name: "status", map: "room", type: "string" },
                { name: "text", map: "name", type: "string" },
                { name: "tags", map: "type", type: "string" },
                { name: "origid", type: "string" },
                { name: "resourceId", map: "type", type: "string" },
                { name: "color", type: "string" }
            ]
        };
        this._headerIcon = "jqx-icon-close";
        this._canCollapse = false;
    }
    RoomAssignComponent.prototype._itemRenderer = function (element, item, resource) {
        jQuery(element).find(".jqx-kanban-item-color-status").html("<img class='menu-icon' src='" + resource.image + "' height='16px' /><span style='line-height: 23px; margin-left: 5px; color:white;'>" + resource.name + "</span>");
    };
    ;
    RoomAssignComponent.prototype.initData = function () {
        var _this = this;
        var rooms = utils_1.sortDevs(this._chsService.Rooms.values());
        this._columns = [this._columnsStart[0]];
        rooms.forEach(function (room) {
            _this._columns.push({ text: room.name, dataField: room.id });
        });
        this._source.localData = [];
        var reaDevs = utils_1.sortDevs(this._chsService.RealDevs.values());
        reaDevs.forEach(function (dev) {
            _this._source.localData.push({ id: dev.id.replace(".", "_"), origid: dev.id, name: dev.name, room: !dev.room ? "noroom" : dev.room, type: dev.type, color: utils_2.backcolor });
        });
        this._da = new $.jqx.dataAdapter(this._source);
    };
    RoomAssignComponent.prototype.getRecord = function (id) {
        if (!this._da)
            return null;
        var records = this._da.records;
        for (var i = 0; i < records.length; ++i) {
            if (records[i].id === id) {
                return records[i];
            }
        }
        return null;
    };
    RoomAssignComponent.prototype.ngOnInit = function () {
        var _this = this;
        this._columnsStart[0].text = this.translation.translate("NOROOM");
        this._chsService.getDevices().subscribe(function (next) { }, function (err) { }, function () {
            _this.initData();
            _this._visible = true;
        });
        this._subscriptionMoved = this._onMoved.subscribe(function (args) { _this.onMovedHandler(args); });
    };
    RoomAssignComponent.prototype.ngOnDestroy = function () {
        if (this._subscriptionMoved) {
            this._subscriptionMoved.unsubscribe();
            this._subscriptionMoved = null;
        }
    };
    RoomAssignComponent.prototype.saveColumnDevs = function (col) {
        var _this = this;
        var room = (col === "noroom" ? null : col);
        var devsToWrite = [];
        var colItems = utils_1.getSortedColumnItems(this._kanban, col);
        var order = 0;
        colItems.forEach(function (ci) {
            var record = _this.getRecord(ci.id);
            var colDev = null;
            if (record) {
                colDev = _this._chsService.getCachedDev(record.origid);
            }
            if (colDev) {
                colDev.room = room;
                colDev.sort = order;
                ++order;
                devsToWrite.push(colDev);
            }
        });
        if (devsToWrite.length > 0) {
            this._chsService.writeDevices(devsToWrite).subscribe(function (next) { }, function (err) { }, function () { });
        }
    };
    RoomAssignComponent.prototype.onMovedHandler = function (args) {
        // neue Spalte komplett speichern
        this.saveColumnDevs(args.newColumn.dataField);
        if (args.newColumn.dataField !== args.oldColumn.dataField) {
            this.saveColumnDevs(args.oldColumn.dataField);
        }
    };
    RoomAssignComponent.prototype.onItemMoved = function (event) {
        var args = event.args;
        this._onMoved.emit(args);
        /*
                let itemData = args.itemData;
                let records = this._da.records;
                // Originale Id holen aus DataAdapter
                var origid: string = "";
                var recordIndex = -1;
                records.forEach((item, index) => {
                    if (item.id == itemData.id) {
                        origid = item.origid;
                        recordIndex = index;
                    }
                });
        
                let dev = this._chsService.getCachedDev(origid);
                if (dev) {
                    dev.room = newroom;
                    this._chsService.writeDevice(dev).subscribe();
                }*/
    };
    return RoomAssignComponent;
}());
__decorate([
    core_1.ViewChild(angular_jqxkanban_1.jqxKanbanComponent),
    __metadata("design:type", angular_jqxkanban_1.jqxKanbanComponent)
], RoomAssignComponent.prototype, "_kanban", void 0);
RoomAssignComponent = __decorate([
    core_1.Component({
        selector: "commeo-roomassign",
        template: "\n\t\t<div class='panel panel-primary'>\n\t\t\t<div class='panel-heading' translate>ASSIGNDEVS</div>\n\t\t\t<div class='panel-body'>\n\t\t\t\t<div *ngIf='_visible'>\n\t\t\t\t\t<jqxKanban  [width]=\"'100%'\" \n\t\t\t\t\t\t[itemRenderer]='_itemRenderer'\n\t\t\t\t\t\t[source]='_da' \n\t\t\t\t\t\t[template]='_template' \n\t\t\t\t\t\t[resources]='_resources'\n\t\t\t\t\t\t[columns]='_columns' \n\t\t\t\t\t\t(onItemMoved)='onItemMoved($event)'>\n\t\t\t\t\t</jqxKanban>\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\n\t\t<a role=\"button\" class=\"btn btn-default\" [routerLink]=\"['/cfg/rooms']\" translate>BACK</a>\n\t"
    }),
    __metadata("design:paramtypes", [angular_l10n_1.TranslationService,
        router_1.ActivatedRoute, router_1.Router,
        chs_service_1.ChsService, translation_service_1.TranslateService])
], RoomAssignComponent);
exports.RoomAssignComponent = RoomAssignComponent;
//# sourceMappingURL=roomassign.component.js.map