"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var chs_service_1 = require("../chs.service");
var RoomeditorComponent = (function () {
    function RoomeditorComponent(_chsService, _router) {
        this._chsService = _chsService;
        this._router = _router;
        this.onDeleted = new core_1.EventEmitter();
        this._edit = false;
    }
    RoomeditorComponent.prototype.onClose = function () {
        this.onDeleted.emit(this.room.id);
    };
    RoomeditorComponent.prototype.onEditToggle = function () {
        // wird nicht aufgerufen, wenn der onValueChange-Handler aktiv ist
        if (this._edit) {
            this._edit = false;
            if (this._oldName != this.room.name) {
                this._chsService.writeDevice(this.room).subscribe(function () { });
            }
        }
        else {
            this._edit = true;
            this._oldName = this.room.name;
            this._input.nativeElement.focus();
        }
    };
    RoomeditorComponent.prototype.ngOnInit = function () {
    };
    RoomeditorComponent.prototype.onFocused = function (event) {
        if (!this._edit) {
            this._oldName = this.room.name;
            this._edit = true;
        }
    };
    RoomeditorComponent.prototype.onValueChanged = function () {
        if (this._input.nativeElement.value != this.room.name)
            this.room.name = this._input.nativeElement.value;
        if (this._edit)
            this.onEditToggle();
    };
    return RoomeditorComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], RoomeditorComponent.prototype, "room", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", Object)
], RoomeditorComponent.prototype, "onDeleted", void 0);
__decorate([
    core_1.ViewChild('nameInput'),
    __metadata("design:type", core_1.ElementRef)
], RoomeditorComponent.prototype, "_input", void 0);
RoomeditorComponent = __decorate([
    core_1.Component({
        selector: 'room-editor',
        template: "\n\t\t\t<div  id=\"{{room.id}}\" class='panel panel-default commeo-icon-container' style='margin-bottom: 8px;'><div class='panel-body'>\n\t\t\t\t<div class='commeo-icon-right1 jqx-icon jqx-icon-close' (click)='onClose()'></div>\n\t\t\t\t<div class='handle commeo-icon-left1 jqx-icon jqx-icon-sort-handle'></div>\n\t\t\t\t<p></p>\n\t\t\t\t<div class=\"input-group\">\n  \t\t\t\t<input type=\"text\" class=\"form-control\" aria-label=\"...\" [(value)]='room.name' (focus)='onFocused($event)' (change)='onValueChanged()' #nameInput>\n  \t\t\t\t<div class=\"input-group-btn\">\n    \t\t\t\t<button type=\"button\" class=\"btn btn-default\" (click)='onEditToggle()'><div class='glyphicon' [class.glyphicon-pencil]='!_edit' [class.glyphicon-ok]='_edit'></div></button>\n  \t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t</div></div>\n\t"
    }),
    __metadata("design:paramtypes", [chs_service_1.ChsService,
        router_1.Router])
], RoomeditorComponent);
exports.RoomeditorComponent = RoomeditorComponent;
//# sourceMappingURL=roomeditor.component.js.map