"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var chs_service_1 = require("../chs.service");
var utils_1 = require("../utils");
var RoomsComponent = (function () {
    function RoomsComponent(el, _route, _router, _chsService) {
        this.el = el;
        this._route = _route;
        this._router = _router;
        this._chsService = _chsService;
        this._headerIcon = "jqx-icon-close";
        this._canCollapse = false;
    }
    RoomsComponent.prototype.initData = function () {
        this._rooms = utils_1.sortDevs(this._chsService.Rooms.values());
    };
    RoomsComponent.prototype.ngOnInit = function () {
        var _this = this;
        this._chsService.getDevices().subscribe(function (next) { }, function (err) { }, function () {
            _this.initData();
        });
    };
    RoomsComponent.prototype.onNewRoom = function () {
        var _this = this;
        this._chsService.newRoom().subscribe(function (dev) {
            _this._rooms.push(dev);
        });
    };
    RoomsComponent.prototype.onRoomDelete = function (id) {
        var _this = this;
        this._chsService.deleteRoom(id).subscribe(function () {
            _this._rooms = _this._rooms.filter(function (s) { return s.id !== id; });
        });
    };
    RoomsComponent.prototype.orderChanged = function () {
        var items = jQuery(this.el.nativeElement).find(".panel.panel-default[id]");
        var ar = [];
        for (var index = 0; index < items.length; index++) {
            var element = jQuery(items[index]);
            var dev = this._chsService.Rooms.get(element.attr("id"));
            dev.sort = index;
            ar.push(dev);
        }
        this._chsService.writeDevices(ar).subscribe(function (next) { }, function (err) { }, function () { });
    };
    return RoomsComponent;
}());
RoomsComponent = __decorate([
    core_1.Component({
        selector: "commeo-rooms",
        template: "\n\t\t<div class='panel panel-primary'>\n\t\t\t<div class='panel-heading' translate>ROOMS</div>\n\t\t\t<jqxSortable class='panel-body' [handle]='\".handle\"' (onStop)=\"orderChanged()\">\n\t\t\t\t<div *ngFor=\"let room of _rooms\">\n\t\t\t\t\t<room-editor [room]=\"room\" (onDeleted)=\"onRoomDelete($event)\"></room-editor>\n\t\t\t\t</div>\n\t\t\t</jqxSortable>\n\t\t</div>\n\t\t<button type=\"button\" class=\"btn btn-default\" (click)=\"onNewRoom()\" translate>NEWROOM</button>\n\t\t<a role=\"button\" class=\"btn btn-default\" [routerLink]=\"['/cfg/roomassign']\" translate>ASSIGNDEVS</a>\n\t"
    }),
    __metadata("design:paramtypes", [core_1.ElementRef, router_1.ActivatedRoute, router_1.Router,
        chs_service_1.ChsService])
], RoomsComponent);
exports.RoomsComponent = RoomsComponent;
//# sourceMappingURL=rooms.component.js.map