"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var chs_service_1 = require("../chs.service");
var angular_l10n_1 = require("angular-l10n");
var DevtargeteditorComponent = (function () {
    function DevtargeteditorComponent(translation, el, _chsService) {
        this.translation = translation;
        this.el = el;
        this._chsService = _chsService;
        this._dropDownTargetSource = [{ label: "", target: "driveUp" }, { label: "", target: "drivePos2" },
            { label: "", target: "drivePos1" }, { label: "", target: "driveDown" }, { label: "", target: "drivePos " }];
    }
    DevtargeteditorComponent.prototype.ngOnInit = function () {
        var _this = this;
        var dtTargets = this._dropDownTargetSource;
        dtTargets[0].label = this.translation.translate("POSUP");
        dtTargets[1].label = this.translation.translate("POSAIR");
        dtTargets[2].label = this.translation.translate("POSINT");
        dtTargets[3].label = this.translation.translate("POSDOWN");
        dtTargets[4].label = this.translation.translate("POSIND");
        this._devType = chs_service_1.ChsService.getTypeState(this.dev.type);
        var m = this.scene.members.find(function (m, idx, obj) { return (m.id === _this.dev.id); });
        if (this._devType === "slider") {
            this._targetPos = 50;
            this._targetState = "driveUp";
        }
        else {
            this._targetState = "off";
        }
        if (m) {
            this._targetState = m.value.toString();
        }
        if (this._targetState.startsWith("drivePos ")) {
            this._targetPos = Number.parseInt(this._targetState.substring(9));
            this._targetState = "drivePos ";
        }
    };
    DevtargeteditorComponent.prototype.saveDev = function () {
        var _this = this;
        var members = this.scene.members;
        var index = -1;
        var m = members.find(function (m, idx, obj) {
            if (m.id === _this.dev.id) {
                index = idx;
                return true;
            }
            return false;
        });
        if (m) {
            m.value = this._targetState;
            if (this._targetState === "drivePos ") {
                m.value = "drivePos " + this._targetPos.toString();
            }
        }
        this._chsService.writeDevice(this.scene).subscribe();
    };
    DevtargeteditorComponent.prototype.onChangeTarget = function (evt) {
        this._targetState = this._dropDownTargetSource[evt.index].target;
        this.dev.device_state = this._targetState;
        if (this._targetState === "drivePos ") {
            this.dev.device_state = "drivePos " + this._targetPos.toString();
        }
        this.saveDev();
    };
    DevtargeteditorComponent.prototype.onChangeTargetSwitch = function (pos) {
        this._targetState = pos;
        this.dev.device_state = this._targetState;
        this.saveDev();
    };
    DevtargeteditorComponent.prototype.onTargetPosChanged = function (args) {
        var pos = Number.parseInt(args.value);
        if (Number.isNaN(pos)) {
            return;
        }
        if (pos !== this._targetPos && pos >= 0 && pos <= 100) {
            this._targetPos = pos;
            this.dev.device_state = "drivePos " + this._targetPos.toString();
            this.saveDev();
        }
    };
    return DevtargeteditorComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], DevtargeteditorComponent.prototype, "dev", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], DevtargeteditorComponent.prototype, "scene", void 0);
DevtargeteditorComponent = __decorate([
    core_1.Component({
        moduleId: module.id,
        selector: "devtarget-editor",
        templateUrl: "devtargeteditor.component.html"
    }),
    __metadata("design:paramtypes", [angular_l10n_1.TranslationService, core_1.ElementRef, chs_service_1.ChsService])
], DevtargeteditorComponent);
exports.DevtargeteditorComponent = DevtargeteditorComponent;
//# sourceMappingURL=devtargeteditor.component.js.map