"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var chs_service_1 = require("../chs.service");
// <a (click)="onGotoMembers()"><img src='css/images/icon-right-transparent.png'/></a>
//				<a [routerLink]="['/Gruppen', 'Gmembers', {id: _id}]" (click)='onGotoMembers()'><img src='css/images/icon-right-transparent.png'/></a>
var SceneeditorComponent = (function () {
    function SceneeditorComponent(_chsService, _router) {
        this._chsService = _chsService;
        this._router = _router;
        this.onDeleted = new core_1.EventEmitter();
        this._edit = false;
        this._timers = [];
    }
    SceneeditorComponent.prototype.ngOnInit = function () {
        var _this = this;
        this._id = this.dev.id.replace(".", "__");
        this._timers = [];
        this._chsService.Timers.forEach(function (dev) { if (dev.type == "timer" && dev.device == _this.dev.id)
            _this._timers.push(dev); });
    };
    SceneeditorComponent.prototype.onClose = function () {
        this.onDeleted.emit(this.dev.id);
    };
    SceneeditorComponent.prototype.onEditToggle = function () {
        // wird nicht aufgerufen, wenn der onValueChange-Handler aktiv ist
        if (this._edit) {
            this._edit = false;
            if (this._oldName != this.dev.name) {
                this._chsService.writeDevice(this.dev).subscribe(function () { });
            }
        }
        else {
            this._edit = true;
            this._oldName = this.dev.name;
            this._input.nativeElement.focus();
        }
    };
    SceneeditorComponent.prototype.onGotoMembers = function () {
        this._router.navigate(["cfg/scenemembers", this._id]);
    };
    SceneeditorComponent.prototype.onTimers = function () {
        this._router.navigate(["cfg/timers", this._id]);
    };
    SceneeditorComponent.prototype.onFavChange = function () {
        this.dev.favorite = !this.dev.favorite;
        this._chsService.setFavorite(this.dev.id, this.dev.favorite);
    };
    SceneeditorComponent.prototype.drive = function (cmd) {
        this._chsService.setDevState(this.dev.id, cmd).subscribe(function () { });
    };
    SceneeditorComponent.prototype.onStartScene = function () {
        this.drive("on");
        /*
        if (!this.dev.members || this.dev.members.length==0)
            return;
            
        var obs: Observable<any>=null;
        (<Member[]>this.dev.members).forEach( m => {
            if (obs)
                obs=obs.merge(this._chsService.setDevState(m.id, m.value.toString()));
            else
                obs=this._chsService.setDevState(m.id, m.value.toString());
        });
        
        if (obs) obs.subscribe();		*/
    };
    SceneeditorComponent.prototype.onStopScene = function () {
        this.drive("stop");
        /*
        if (!this.dev.members || this.dev.members.length==0)
            return;
            
        var obs: Observable<any>=null;
        (<Member[]>this.dev.members).forEach( m => {
            if (obs)
                obs=obs.merge(this._chsService.setDevState(m.id, 'stop'));
            else
                obs=this._chsService.setDevState(m.id, 'stop');
        });
        
        if (obs) obs.subscribe();		*/
    };
    SceneeditorComponent.prototype.onFocused = function (event) {
        if (!this._edit) {
            this._oldName = this.dev.name;
            this._edit = true;
        }
    };
    SceneeditorComponent.prototype.onValueChanged = function () {
        if (this._input.nativeElement.value != this.dev.name)
            this.dev.name = this._input.nativeElement.value;
        if (this._edit)
            this.onEditToggle();
    };
    return SceneeditorComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], SceneeditorComponent.prototype, "dev", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", Object)
], SceneeditorComponent.prototype, "onDeleted", void 0);
__decorate([
    core_1.ViewChild("nameInput"),
    __metadata("design:type", core_1.ElementRef)
], SceneeditorComponent.prototype, "_input", void 0);
SceneeditorComponent = __decorate([
    core_1.Component({
        selector: "scene-editor",
        template: "\n\t\t\t<div  id=\"{{dev.id}}\" class='panel panel-default commeo-icon-container' style='margin-bottom: 8px;'><div class='panel-body'>\n\t\t\t\t<div class='commeo-icon-right1 jqx-icon jqx-icon-close' (click)='onClose()'></div>\n\t\t\t\t<div class='handle commeo-icon-left1 jqx-icon jqx-icon-sort-handle'></div>\n\t\t\t\t<p></p>\n\t\t\t\t<div class=\"input-group\">\n  \t\t\t\t<input type=\"text\" class=\"form-control\" aria-label=\"...\" [(value)]='dev.name' (focus)='onFocused($event)' (change)='onValueChanged()' #nameInput>\n  \t\t\t\t<div class=\"input-group-btn\">\n    \t\t\t\t<button type=\"button\" class=\"btn btn-default\" (click)='onEditToggle()'><div class='glyphicon' [class.glyphicon-pencil]='!_edit' [class.glyphicon-ok]='_edit'></div></button>\n    \t\t\t\t<button type=\"button\" class=\"btn btn-default\" (click)='onFavChange()'><div class='glyphicon' [class.glyphicon-star-empty]='!dev.favorite' [class.glyphicon-star]='dev.favorite' ></div></button>\n    \t\t\t\t<button type=\"button\" class=\"btn btn-default\" (click)='onGotoMembers()'><div class='glyphicon glyphicon-menu-right'></div></button>\n  \t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t\t<p></p>\n\t\t\t\t<div class=\"btn-group\" role=\"group\" aria-label=\"...\">\n\t\t\t\t\t<button type=\"button\" class=\"btn btn-default\" (click)='onStopScene()'><div class='glyphicon glyphicon-stop'></div></button>\n\t\t\t\t\t<button type=\"button\" class=\"btn btn-default\" (click)='onStartScene()'><div class='glyphicon glyphicon-play'></div></button>\n\t\t\t\t</div>\n\t\t\t\t<p></p>\n\t\t\t\t<jqxExpander [expanded]='false'>\n\t\t\t\t\t<div><span translate>SWITCHTIMES</span>\t\t\t\t\t\n\t\t\t\t\t\t<button (click)='onTimers()' class='glyphicon glyphicon-pencil'></button>\n\t\t\t\t\t</div>\n\t\t\t\t\t<ul class=\"list-group\">\n\t\t\t\t\t\t<li *ngFor=\"let timer of _timers\" class='list-group-item'>\n\t\t\t\t\t\t\t<timer-display [timer]=\"timer\"></timer-display>\n\t\t\t\t\t\t</li>\n\t\t\t\t\t</ul>\n\t\t\t\t</jqxExpander>\n\t\t\t</div></div>\n\t"
    }),
    __metadata("design:paramtypes", [chs_service_1.ChsService,
        router_1.Router])
], SceneeditorComponent);
exports.SceneeditorComponent = SceneeditorComponent;
//# sourceMappingURL=sceneeditor.component.js.map