"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var angular_l10n_1 = require("angular-l10n");
var chs_service_1 = require("../chs.service");
var translation_service_1 = require("../translation.service");
var sceneDataAdapter_1 = require("./sceneDataAdapter");
var angular_jqxkanban_1 = require("../jqwidgets-ts/angular_jqxkanban");
var ScenemembersComponent = (function () {
    function ScenemembersComponent(translation, _route, _router, _chsService, _transService) {
        this.translation = translation;
        this._route = _route;
        this._router = _router;
        this._chsService = _chsService;
        this._transService = _transService;
        this._columns = [{ text: "DEVICES", dataField: "noscene" }, { text: "", dataField: "" }];
        this._template = "\n\t\t\t\t\t\t\t\t<div groups class='jqx-kanban-item' id=''>\n\t\t\t\t\t\t\t\t\t<div groups class='jqx-kanban-item-color-status'></div>\n\t\t\t\t\t\t\t\t\t<div groups style='display: none' class='jqx-kanban-item-avatar'></div>\n\t\t\t\t\t\t\t\t\t<div groups class='jqx-kanban-item-text'></div>\n\t\t\t\t\t\t\t\t\t<div groups style='display: none' class='jqx-kanban-item-footer'></div>\n\t\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t";
        this._itemRenderer = function (element, item, resource) {
            var bInScene = (item.status !== "noscene");
            jQuery(element).find(".jqx-kanban-item-color-status").html("<img class='menu-icon' src='" + resource.image + "' height='16px' /><span style='line-height: 23px; margin-left: 5px; color:white;'>" + resource.name + "</span>");
            var textElem = jQuery(element).find(".jqx-kanban-item-text");
            if (!bInScene) {
                textElem.html(item.text);
            }
            else if (item.targetState) {
                var strHtml = "";
                if (item.targetState === "driveUp")
                    strHtml = "Obere Endlage";
                else if (item.targetState === "driveDown")
                    strHtml = "Untere Endlage";
                else if (item.targetState === "drivePos1")
                    strHtml = "Zwischenposition";
                else if (item.targetState === "drivePos2")
                    strHtml = "Lüftungsposition";
                else if ((item.targetState).startsWith("drivePos"))
                    strHtml = (item.targetState).substring(8) + "%";
                textElem.html(item.text + "<p>" + strHtml + "</p>");
            }
        };
        this._id = this._route.snapshot.params["id"].replace("__", ".");
        this._da = new sceneDataAdapter_1.SceneDataAdapter(_chsService);
        this._resources = this._da.resources();
    }
    ScenemembersComponent.prototype.ngOnInit = function () {
        var _this = this;
        var s = this._chsService.getCachedDev(this._id);
        if (s) {
            this.initData(s);
        }
        else {
            this._chsService.getDevices().subscribe(function (x) { }, function (error) { }, function () {
                s = _this._chsService.getCachedDev(_this._id);
                _this.initData(s);
            });
        }
    };
    ScenemembersComponent.prototype.initData = function (s) {
        this._scene = s;
        this._da.setDevicesForScene(this._scene.id);
        this._source = this._da.dataAdapter();
        this._columns[0].text = this.translation.translate("DEVS");
        this._columns[1].text = this._scene.name;
        this._columns[1].dataField = this._scene.id;
    };
    ScenemembersComponent.prototype.onItemMoved = function (event) {
        var _this = this;
        var args = event.args;
        if (args.oldColumn.dataField !== args.newColumn.dataField) {
            var itemData_1 = args.itemData;
            // Originale Id holen aus DataAdapter
            var records = this._source.records;
            var origid = "";
            records.forEach(function (item) {
                if (item.id === itemData_1.id) {
                    origid = item.origid;
                    _this._kanban.updateItem(item.id, item);
                }
            });
            if (args.newColumn.dataField === "noscene")
                this._chsService.removeFromScene(origid, args.oldColumn.dataField).subscribe(function () { });
            else
                this._chsService.addToScene(origid, args.newColumn.dataField, "driveUp").subscribe(function () { });
        }
    };
    ScenemembersComponent.prototype.onTargets = function () {
        this._router.navigate(["cfg/scenetargets", this._id.replace(".", "__")]);
    };
    return ScenemembersComponent;
}());
__decorate([
    core_1.ViewChild(angular_jqxkanban_1.jqxKanbanComponent),
    __metadata("design:type", angular_jqxkanban_1.jqxKanbanComponent)
], ScenemembersComponent.prototype, "_kanban", void 0);
ScenemembersComponent = __decorate([
    core_1.Component({
        template: "\n\t\t\t\t<div class='panel panel-primary'>\n\t\t\t\t\t<div class='panel-heading'><span translate>ASSIGNMEMBERS</span> {{_scene?.name}}</div>\n\t\t\t\t\t<div class='panel-body'>\n\t\t\t\t\t\t<div *ngIf='_scene'>\n\t\t\t\t\t\t\t<jqxKanban\n\t\t\t\t\t\t\t\t[width]=\"'100%'\" [itemRenderer]='_itemRenderer'\n\t\t\t\t\t\t\t\t[source]='_source' [template]='_template' [resources]='_resources'\n\t\t\t\t\t\t\t\t[columns]='_columns' (onItemMoved)='onItemMoved($event)'>\n\t\t\t\t\t\t\t</jqxKanban>\n\t\t\t\t\t\t</div>\n\t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t\t<a role=\"button\" class=\"btn btn-default\" [routerLink]=\"['/cfg/scenes']\" translate>BACK</a>\n\t\t\t\t<button type=\"button\" class=\"btn btn-default\" (click)=\"onTargets()\" translate>CONFIGTARGETS</button>\n      "
    }),
    __metadata("design:paramtypes", [angular_l10n_1.TranslationService,
        router_1.ActivatedRoute, router_1.Router,
        chs_service_1.ChsService, translation_service_1.TranslateService])
], ScenemembersComponent);
exports.ScenemembersComponent = ScenemembersComponent;
//# sourceMappingURL=scenemembers.component.js.map