"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var chs_service_1 = require("../chs.service");
var sceneDataAdapter_1 = require("./sceneDataAdapter");
var ScenesComponent = (function () {
    function ScenesComponent(el, _chsService) {
        this.el = el;
        this._chsService = _chsService;
        this._scenes = [];
        this._da = new sceneDataAdapter_1.SceneDataAdapter(_chsService);
    }
    ScenesComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this._chsService.getDevices().subscribe(function (devs) {
            _this._da.setDevices();
            try {
                _this._scenes = [];
                _this._chsService.Scenes.forEach(function (dev) { if (dev.type == "scene")
                    _this._scenes.push(dev); });
            }
            catch (ex) { }
        }, function (error) { });
    };
    ScenesComponent.prototype.onNewScene = function () {
        var _this = this;
        this._chsService.newScene().subscribe(function (scene) {
            _this._scenes.push(scene);
        });
    };
    ScenesComponent.prototype.onSceneDelete = function (id) {
        var _this = this;
        this._chsService.deleteScene(id).subscribe(function () {
            _this._scenes = _this._scenes.filter(function (s) { return s.id != id; });
        });
    };
    ScenesComponent.prototype.orderChanged = function () {
        var items = jQuery(this.el.nativeElement).find(".panel.panel-default[id]");
        var ar = [];
        for (var index = 0; index < items.length; index++) {
            var element = jQuery(items[index]);
            var dev = this._chsService.Scenes.get(element.attr("id"));
            dev.sort = index;
            ar.push(dev);
        }
        this._chsService.writeDevices(ar).subscribe(function (next) { }, function (err) { }, function () { });
    };
    return ScenesComponent;
}());
ScenesComponent = __decorate([
    core_1.Component({
        template: "\n\t\t\t<div class='panel panel-primary'>\n\t\t\t\t<div class='panel-heading' translate>SCENES</div>\n\t\t\t\t<jqxSortable id='scenelist' class='panel-body' [handle]='\".handle\"' (onStop)=\"orderChanged()\">\n\t\t\t\t\t<div *ngFor=\"let scene of _scenes\">\n\t\t\t\t\t\t<scene-editor [dev]=\"scene\" (onDeleted)=\"onSceneDelete($event)\"></scene-editor>\n\t\t\t\t\t</div>\n\t\t\t\t</jqxSortable>\n\t\t\t</div>\n\t\t\t<button type=\"button\" class=\"btn btn-default\" (click)=\"onNewScene()\" translate>NEWSCENE</button>\n\t\t\t"
    }),
    __metadata("design:paramtypes", [core_1.ElementRef, chs_service_1.ChsService])
], ScenesComponent);
exports.ScenesComponent = ScenesComponent;
//# sourceMappingURL=scenes.component.js.map