import { Component, OnInit } from "@angular/core";
import { Router, ActivatedRoute } from "@angular/router";
import { ChsService } from "../chs.service";
import { Device, Member } from "../devices/device";

@Component({
	template: `
			<div class='panel panel-primary'>
				<div class='panel-heading' translate>TARGETSTATES</div>
				<div id='devicelist' class='panel-body'>
					<div *ngFor="let device of _devices" class='panel panel-default'>
						<div class='panel-heading'>{{device.name}}</div>
						<div class='panel-body'>
							<devtarget-editor [dev]="device" [scene]="_scene"></devtarget-editor>
						</div>
					</div>
				</div>
			</div>
			<button type="button" class="btn btn-default" (click)="onBack()" translate>BACK</button>
			`
})
export class ScenetargetsComponent implements OnInit {
	private _id: string;
	private _scene: Device;
	private _devices: Device[] = [];

	constructor(private _chsService: ChsService, private _route: ActivatedRoute, private _router: Router) {
		this._id = this._route.snapshot.params["id"];
	}

	
	private initDevices(dev: Device) {
		this._scene=dev;

		(<Member[]>this._scene.members).forEach(m => {
			let dev=this._chsService.RealDevs.get(m.id);
			if (dev) {
				dev.device_state=m.value.toString();
				this._devices.push(dev);
			}

		});
	}

	ngOnInit() {
		let s = this._chsService.getCachedDev(this._id.replace("__", "."));
		if (s) {
			this.initDevices(s);
		}
		else {
			this._chsService.getDevices().subscribe(x => {},
				error => {},
				() => {
					s=this._chsService.getCachedDev(this._id.replace("__", "."));
					this.initDevices(s);
				}
			);
		}
	}
	
	onBack() {
 		 this._router.navigate(["cfg/scenemembers", this._id]);
	}
}