"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var chs_service_1 = require("../chs.service");
var settings_service_1 = require("./settings.service");
var moment = require("moment");
var SettingClockComponent = (function () {
    function SettingClockComponent(_chsService, _settingsService, formBuilder) {
        this._chsService = _chsService;
        this._settingsService = _settingsService;
        this.formBuilder = formBuilder;
        this._model = { ntp: false, time: 0, timezone: "Europe/Berlin", zonelist: ["Europe/Berlin", "Europe/Amsterdam"] };
    }
    SettingClockComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this._chsService.getDateTime().subscribe(function (timeSettings) {
            if (timeSettings) {
                _this._model = timeSettings;
                var m = moment.unix(timeSettings.time);
                _this._dtTime = m.toDate();
                if (_this._model.ntp === undefined)
                    _this._model.ntp = false;
                if (_this._model.timezone === undefined)
                    _this._model.timezone = "";
                if (!_this._model.zonelist) {
                    _this._model.zonelist = ["Europe/Berlin", "Europe/Amsterdam"];
                }
                for (var i = 0; i < _this._model.zonelist.length; ++i) {
                    if (_this._model.timezone === _this._model.zonelist[i]) {
                        _this._tzIndex = i;
                        break;
                    }
                }
            }
        }, function (err) { }, function () { });
    };
    SettingClockComponent.prototype.onDateTimeChanged = function (event) {
        this.onDtChange(event.args);
    };
    SettingClockComponent.prototype.onTzChanged = function (event) {
        this._tzIndex = event.args.index;
        this._model.timezone = this._model.zonelist[this._tzIndex];
    };
    SettingClockComponent.prototype.onDtChange = function (args) {
        if (args.oldValue instanceof Date && !moment(args.date).isSame(args.oldValue)) {
            this._dtTime = args.date;
        }
    };
    // tslint:disable-next-line:no-unused-variable
    SettingClockComponent.prototype.onSubmit = function () {
        /*let st: SettingTime = { ntp: this._model.ntp, time: moment(this._dtTime).unix(),
            timezone: this._model.timezone };*/
        var st = { ntp: this._model.ntp, time: moment(this._dtTime).unix(),
            timezone: this._model.timezone };
        this._chsService.setDateTime(st).subscribe();
    };
    return SettingClockComponent;
}());
SettingClockComponent = __decorate([
    core_1.Component({
        moduleId: module.id,
        selector: "clock-setting",
        templateUrl: "setting.clock.component.html"
    }),
    __metadata("design:paramtypes", [chs_service_1.ChsService, settings_service_1.SettingsService, forms_1.FormBuilder])
], SettingClockComponent);
exports.SettingClockComponent = SettingClockComponent;
//# sourceMappingURL=setting.clock.component.js.map