import { Component } from "@angular/core";
import { Translation, TranslationService } from "angular-l10n";
import { ChsService } from "../chs.service";
import { SettingsService } from "./settings.service";
import { FileUploader } from "ng2-file-upload";

@Component({
	moduleId: module.id,
	selector: "import-settings",
	template: `
			<div class="form-group">
				<label for="configFile" translate>SETTINGSFILE</label>
				<input class="form-control form-input input-sm" type="file" ng2FileSelect id="import" name="import" [uploader]="uploader" />
				<p></p>
				<div class="progress" *ngIf="uploader.getNotUploadedItems().length>0">
					<div class="progress-bar" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" [ngStyle]="{ 'width': uploader.progress + '%' }">
  				</div>
				</div>
				<p></p>
			</div>
			<button type="button" class="btn btn-default btn-sm" [disabled]="uploader.getNotUploadedItems().length==0" (click)="uploader.uploadAll()" translate>LOAD</button>
	`
})
export class SettingImportComponent   {
	public uploader:FileUploader = new FileUploader({url: "/import", disableMultipart: false, itemAlias: "import" });

	constructor(public translation: TranslationService,
		private _chsService: ChsService, private _settingsService: SettingsService, ) {
		 
	}

	private onLoad(): void {
		this.uploader.uploadAll();
	}

}