"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var angular_l10n_1 = require("angular-l10n");
var chs_service_1 = require("../chs.service");
var settings_service_1 = require("./settings.service");
var SettingLanguageComponent = (function () {
    function SettingLanguageComponent(locale, translation, _chsService, _settingsService, formBuilder) {
        this.locale = locale;
        this.translation = translation;
        this._chsService = _chsService;
        this._settingsService = _settingsService;
        this.formBuilder = formBuilder;
        this._browserLang = this._settingsService.getBrowserLanguage();
        this._dropDownLanguageSource = this._settingsService.LANGUAGES;
        var lang = this.locale.getCurrentLanguage();
        if (lang) {
            this._index = this._settingsService.getLanguageIndex(lang);
        }
        this._language = this._settingsService.LANGUAGES[this._index];
        this.locale.languageCodeChanged.subscribe(function () {
            location.reload(true);
        });
    }
    SettingLanguageComponent.prototype.onSubmit = function () {
        this.locale.setCurrentLanguage(this._language.iso);
    };
    SettingLanguageComponent.prototype.onLanguageChanged = function (index) {
        this._index = index;
        this._language = this._settingsService.LANGUAGES[this._index];
    };
    return SettingLanguageComponent;
}());
SettingLanguageComponent = __decorate([
    core_1.Component({
        moduleId: module.id,
        selector: "language-setting",
        templateUrl: "setting.language.component.html"
    }),
    __metadata("design:paramtypes", [angular_l10n_1.LocaleService, angular_l10n_1.TranslationService,
        chs_service_1.ChsService, settings_service_1.SettingsService, forms_1.FormBuilder])
], SettingLanguageComponent);
exports.SettingLanguageComponent = SettingLanguageComponent;
//# sourceMappingURL=setting.language.component.js.map