"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var angular_l10n_1 = require("angular-l10n");
var chs_service_1 = require("../chs.service");
var settings_service_1 = require("./settings.service");
var angular_jqxdropdownlist_1 = require("../jqwidgets-ts/angular_jqxdropdownlist");
var angular_jqxnumberinput_1 = require("../jqwidgets-ts/angular_jqxnumberinput");
var SettingLocationComponent = SettingLocationComponent_1 = (function () {
    function SettingLocationComponent(translation, _chsService, _settingsService, formBuilder) {
        this.translation = translation;
        this._chsService = _chsService;
        this._settingsService = _settingsService;
        this.formBuilder = formBuilder;
        this._index = 0;
        this._location = this._settingsService.CITIES[1];
        this._dropDownCitySource = this._settingsService.CITIES;
        this._location = this._chsService.getStoredSetting(SettingLocationComponent_1._SettingId);
        this.calcIndex();
    }
    SettingLocationComponent.prototype.calcIndex = function () {
        if (this._location && this._location.city) {
            for (var i = 0; i < this._settingsService.CITIES.length; ++i) {
                if (this._settingsService.CITIES[i].key === this._location.key) {
                    this._index = i;
                    i = this._settingsService.CITIES.length;
                }
            }
        }
        else {
            this._index = 1; // Kassel ist default
            if (!this._location) {
                this._location = this._settingsService.CITIES[this._index];
            }
        }
    };
    SettingLocationComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this._index = 0;
        this._location = this._settingsService.CITIES[this._index];
        this._dropDownLoc.createComponent();
        //this._numberInputLat.createComponent();
        //this._numberInputLong.createComponent();
        this._chsService.onGotSettings.subscribe(function () {
            _this._location = _this._chsService.getStoredSetting(SettingLocationComponent_1._SettingId);
            _this.calcIndex();
            _this._dropDownLoc.selectedIndex(_this._index);
            //console.debug("Location " + this._index + ": " + this._location.city);
        });
    };
    SettingLocationComponent.prototype.onSubmit = function () {
        if (this._index == 0) {
            this._location.latitude = this._numberInputLat.getDecimal();
            this._location.longitude = this._numberInputLong.getDecimal();
        }
        this._chsService.setSetting(SettingLocationComponent_1._SettingId, this._location).subscribe();
    };
    SettingLocationComponent.prototype.onCityChanged = function (event) {
        this._index = event;
        if (this._index !== 0) {
            this._location = this._settingsService.CITIES[this._index];
        }
        else {
            this._location.city = this._settingsService.CITIES[0].city;
            this._location.key = this._settingsService.CITIES[0].key;
        }
        console.debug("Location " + this._index + ": " + this._location.city);
    };
    return SettingLocationComponent;
}());
SettingLocationComponent._SettingId = "location";
__decorate([
    core_1.ViewChild("dropDownLoc"),
    __metadata("design:type", angular_jqxdropdownlist_1.jqxDropDownListComponent)
], SettingLocationComponent.prototype, "_dropDownLoc", void 0);
__decorate([
    core_1.ViewChild("numberInputLat"),
    __metadata("design:type", angular_jqxnumberinput_1.jqxNumberInputComponent)
], SettingLocationComponent.prototype, "_numberInputLat", void 0);
__decorate([
    core_1.ViewChild("numberInputLong"),
    __metadata("design:type", angular_jqxnumberinput_1.jqxNumberInputComponent)
], SettingLocationComponent.prototype, "_numberInputLong", void 0);
SettingLocationComponent = SettingLocationComponent_1 = __decorate([
    core_1.Component({
        moduleId: module.id,
        selector: "location-setting",
        templateUrl: "setting.location.component.html"
    }),
    __metadata("design:paramtypes", [angular_l10n_1.TranslationService,
        chs_service_1.ChsService, settings_service_1.SettingsService, forms_1.FormBuilder])
], SettingLocationComponent);
exports.SettingLocationComponent = SettingLocationComponent;
var SettingLocationComponent_1;
//# sourceMappingURL=setting.location.component.js.map