import { Component } from "@angular/core";
import { FormBuilder } from "@angular/forms";
import { Translation, LocaleService, TranslationService } from "angular-l10n";
import { ChsService } from "../chs.service";
import { SettingsService } from "./settings.service";
import { Location, IMySelve } from "./setting.models";
import { Subscription } from "rxjs/Subscription";

@Component({
	moduleId: module.id,
	selector: "myselve-setting",
	templateUrl: "setting.myselve.component.html"
})
export class SettingMyselveComponent   {
	private static _SettingId = "myselve";
	private _index = 0;
	private _model: IMySelve;
	private _name: string;

	constructor(public translation: TranslationService, 
							private _chsService: ChsService, private _settingsService: SettingsService, private formBuilder: FormBuilder) {
		 
		this._index = 0;
		this._model = { name: "", descr: "", activationcode: "" };
		this._chsService.onGotSettings.subscribe(() => {
			let ms: IMySelve = <IMySelve>this._chsService.getStoredSetting(SettingMyselveComponent._SettingId);
			if (ms) {
				this._model=ms;
				this._name=this._model.name;
			}
		});
	}

	private onSubmit(): void {
		this._name = this._model.name;
		let subs: Subscription;
		this._chsService.setSetting(SettingMyselveComponent._SettingId, this._model).subscribe(() => {
			subs = this._chsService.pollSetting<IMySelve>(SettingMyselveComponent._SettingId).subscribe((ms: IMySelve) => {
				if (ms && ms.password) {
					subs.unsubscribe();
					this._model=ms;
				}
			});

 		});
	}

	private onDeregister(): void {
		this._chsService.deleteSetting(SettingMyselveComponent._SettingId).subscribe(() => {
				this._name = null;
				this._model = { name: "", descr: "", activationcode: "" };
		});
	}
}