"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var angular_l10n_1 = require("angular-l10n");
var chs_service_1 = require("../chs.service");
var auth_service_1 = require("../auth.service");
var md5_1 = require("../md5");
var SettingPasswordComponent = (function () {
    function SettingPasswordComponent(locale, translation, _chsService, _authService, formBuilder) {
        var _this = this;
        this.locale = locale;
        this.translation = translation;
        this._chsService = _chsService;
        this._authService = _authService;
        this.formBuilder = formBuilder;
        this._strOldPass = "";
        this._invalidOldPass = false;
        this._chsService.onGotSettings.subscribe(function () {
            var pass = _this._chsService.getStoredSetting(_this.passwordFor);
        });
    }
    SettingPasswordComponent.prototype.onSubmit = function (event) {
        var pass = this._chsService.getStoredSetting(this.passwordFor);
        var oldMd5 = "";
        if (this._strOldPass)
            oldMd5 = md5_1.md5(this._strOldPass);
        if (pass && pass !== oldMd5) {
            this._invalidOldPass = true;
        }
        else {
            this._invalidOldPass = false;
            var strMd5 = md5_1.md5(this._strNewPass);
            this._chsService.setSetting(this.passwordFor, strMd5).subscribe();
            this._authService.storeHash(strMd5);
            this._authService.login(strMd5);
        }
        return false;
    };
    SettingPasswordComponent.prototype.onDelPassword = function () {
        var pass = this._chsService.getStoredSetting(this.passwordFor);
        var mac = this._chsService.getStoredSetting("mac");
        if (pass && md5_1.md5(this._strOldPass) === pass || mac === this._strOldPass) {
            this._chsService.deleteSetting(this.passwordFor).subscribe();
            this._authService.storeHash("");
            this._invalidOldPass = false;
        }
        else {
            this._invalidOldPass = true;
        }
    };
    return SettingPasswordComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], SettingPasswordComponent.prototype, "ShowNoPass", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], SettingPasswordComponent.prototype, "passwordFor", void 0);
SettingPasswordComponent = __decorate([
    core_1.Component({
        moduleId: module.id,
        selector: "password-setting",
        templateUrl: "setting.password.component.html",
    }),
    __metadata("design:paramtypes", [angular_l10n_1.LocaleService, angular_l10n_1.TranslationService, chs_service_1.ChsService, auth_service_1.AuthService, forms_1.FormBuilder])
], SettingPasswordComponent);
exports.SettingPasswordComponent = SettingPasswordComponent;
//# sourceMappingURL=setting.password.component.js.map