import { Component, Input } from "@angular/core";
import { FormBuilder } from "@angular/forms";
import { Translation, LocaleService, TranslationService } from "angular-l10n";
import { ChsService } from "../chs.service";
import { AuthService } from "../auth.service";
import { md5 } from "../md5";

@Component({
	moduleId: module.id,
	selector: "password-setting",
	templateUrl: "setting.password.component.html",
})
export class SettingPasswordComponent   {
	@Input() ShowNoPass: boolean;
	@Input() passwordFor: string;
	private _strOldPass: string = "";
	private _strNewPass: string;
	private _strNewPass2: string;
	private _noPass: boolean;
	private _invalidOldPass: boolean = false;

	constructor(public locale: LocaleService, public translation: TranslationService, private _chsService: ChsService, private _authService: AuthService, private formBuilder: FormBuilder) {
		 
		this._chsService.onGotSettings.subscribe(() => {
			let pass = this._chsService.getStoredSetting(this.passwordFor);
		});
	}

	private onSubmit(event: any): boolean {
		let pass = this._chsService.getStoredSetting(this.passwordFor);
		let oldMd5 = "";
		if (this._strOldPass)
			oldMd5 = md5(this._strOldPass);
		if (pass && pass!==oldMd5) {
			this._invalidOldPass=true;
		}
		else {
			this._invalidOldPass=false;
			let strMd5: string = md5(this._strNewPass);
			this._chsService.setSetting(this.passwordFor, strMd5).subscribe();
			this._authService.storeHash(strMd5);
			this._authService.login(strMd5);
		}

		return false;
	}

	private onDelPassword(): void {
		let pass = this._chsService.getStoredSetting(this.passwordFor);
		let mac = this._chsService.getStoredSetting("mac");

		if (pass && md5(this._strOldPass)===pass || mac===this._strOldPass) {
			this._chsService.deleteSetting(this.passwordFor).subscribe();
			this._authService.storeHash("");
			this._invalidOldPass=false;
		}
		else {
			this._invalidOldPass=true;
		}

	}
}
