import { Component } from "@angular/core";
import { FormBuilder, Validators } from "@angular/forms";
import { Translation, TranslationService } from "angular-l10n";
import { ChsService } from "../chs.service";
import { SettingsService } from "./settings.service";
import { Subscription } from "rxjs/Subscription";
import { FileUploader } from "ng2-file-upload";
import "bootstrap";
import "bootstrap-extra";
import { Version } from "../version";

@Component({
	moduleId: module.id,
	selector: "update-settings",
	templateUrl: "setting.update.component.html",
})
export class SettingUpdateComponent   {
	private _updating: boolean;
	private _version: string;
	public uploader: FileUploader = new FileUploader({ url: "/update", disableMultipart: false, itemAlias: "update" });

	constructor(public translation: TranslationService,
		private _chsService: ChsService, private _settingsService: SettingsService) {
		 
		this.uploader.onCompleteAll = () => { this.onCompleteUpload(); };
		this._chsService.getVersion().subscribe((v: Version) => {
			this._version = v.version;
		});
	}

	private onLoad(): void {
		this.uploader.uploadAll();

	}

	onCompleteUpload() {
		this._updating = true;
		let bApiOnline =false;

		setInterval(() => {
			let sub = this._chsService.getVersionRaw().subscribe((val: any) => {
				window.location.href="/";
			});
		}, 60000);
	}
}