import { NgModule } from "@angular/core";
import { CommonModule } from "@angular/common";
import { FormsModule, ReactiveFormsModule } from "@angular/forms";
import { TranslationModule } from "angular-l10n";
import { EqualTextValidator } from "angular2-text-equality-validator";
import { SharedModule } from "../shared/shared.module";
import { JqwidgetsModule } from "../jqwidgets-ts/jqwidgets.module";
import { SettingsComponent } from "./settings.component";
import { SettingLocationComponent } from "./setting.location.component";
import { SettingLanguageComponent } from "./setting.language.component";
import { SettingPasswordComponent } from "./setting.password.component";
import { SettingClockComponent } from "./setting.clock.component";
import { SettingImportComponent } from "./setting.import.component";
import { SettingUpdateComponent } from "./setting.update.component";
import { SettingMyselveComponent } from "./setting.myselve.component";
import { SettingsService } from "./settings.service";
import { FileUploadModule } from "ng2-file-upload";

@NgModule({
  imports: [
    TranslationModule.forChild(),
    CommonModule, FormsModule, ReactiveFormsModule, JqwidgetsModule, SharedModule, FileUploadModule],
  declarations: [
    EqualTextValidator,
    SettingsComponent, SettingLocationComponent, SettingLanguageComponent,
    SettingPasswordComponent, SettingClockComponent, SettingImportComponent,
    SettingUpdateComponent, SettingMyselveComponent
  ],
  exports: [
    SettingLocationComponent, SettingLanguageComponent, SettingPasswordComponent, SettingClockComponent,
    SettingImportComponent, SettingUpdateComponent, SettingMyselveComponent],
  providers: [SettingsService]
})
export class SettingsModule { }