"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var angular_l10n_1 = require("angular-l10n");
var SettingsService = (function () {
    function SettingsService(translation) {
        var _this = this;
        this.translation = translation;
        this.CITIES = [
            { key: "CUSTOMLOC", city: "Eigene Angaben", latitude: 0, longitude: 0 },
            { key: "KASSEL", city: "Kassel", latitude: 51.3, longitude: 9.5 },
            { key: "BERLIN", city: "Berlin", latitude: 52.2, longitude: 13.4 },
            { key: "HAMBURG", city: "Hamburg", latitude: 53.6, longitude: 10.0 },
            { key: "COLOGNE", city: "Köln", latitude: 50.9, longitude: 7 },
            { key: "STUTTGART", city: "Stuttgart", latitude: 48.8, longitude: 9.2 },
            { key: "MUNICH", city: "München", latitude: 48.1, longitude: 11.6 },
            { key: "VIENNA", city: "Wien", latitude: 48.2, longitude: 16.4 },
            { key: "KLAGENFURT", city: "Klagenfurt", latitude: 46.6, longitude: 14.3 },
            { key: "BERN", city: "Bern", latitude: 46.9, longitude: 7.4 },
            { key: "PARIS", city: "Paris", latitude: 48.8, longitude: 2.4 },
            { key: "RENNES", city: "Rennes", latitude: 48.1, longitude: -1.7 },
            { key: "BORDEAUX", city: "Bordeaux", latitude: 44.8, longitude: -0.6 },
            { key: "LYON", city: "Lyon", latitude: 45.8, longitude: 4.8 },
            { key: "BRUSSELS", city: "Brüssel", latitude: 50.8, longitude: 4.4 },
            { key: "AMSTERDAM", city: "Amsterdam", latitude: 52.4, longitude: 4.9 },
            { key: "WARSAW", city: "Warschau", latitude: 52.2, longitude: 21 },
            { key: "POZNAN", city: "Poznan", latitude: 52.4, longitude: 17 },
            { key: "PRAGUE", city: "Prag", latitude: 50.1, longitude: 14.4 },
            { key: "BUDAPEST", city: "Budapest", latitude: 47.5, longitude: 19 },
            { key: "ZAGREB", city: "Zagreb", latitude: 45.8, longitude: 16 },
            { key: "MADRID", city: "Madrid", latitude: 40.4, longitude: -3.7 },
            { key: "BARCELONA", city: "Barcelona", latitude: 41.4, longitude: 2.2 },
            { key: "LISBON", city: "Lissabon", latitude: 38.7, longitude: -9.1 }
        ];
        this.LANGUAGES = [
            //{ key: "LANGAUTO", language: "", iso: "", country: ""},
            { key: "GERMAN", language: "", iso: "de", country: "DE" },
            { key: "ENGLISH", language: "", iso: "en", country: "GB" },
            { key: "FRENCH", language: "", iso: "fr", country: "FR" },
            { key: "DUTCH", language: "", iso: "nl", country: "NL" },
            { key: "POLISH", language: "", iso: "pl", country: "PL" },
            { key: "CZECH", language: "", iso: "cs", country: "CZ" }
        ];
        this.translateCities();
        this.translateLanguages();
        this.translation.translationChanged.subscribe(function () {
            _this.translateCities();
            _this.translateLanguages();
        });
    }
    SettingsService.prototype.translateCities = function () {
        var _this = this;
        this.CITIES.forEach(function (loc) {
            loc.city = _this.translation.translate(loc.key);
        });
    };
    SettingsService.prototype.translateLanguages = function () {
        var _this = this;
        this.LANGUAGES.forEach(function (lang) {
            lang.language = _this.translation.translate(lang.key);
        });
    };
    SettingsService.prototype.getBrowserLanguage = function () {
        var lang = navigator.language;
        var nMinus = lang.indexOf("-");
        if (nMinus > 0) {
            lang = lang.substring(0, nMinus);
        }
        for (var i = 0; i < this.LANGUAGES.length; ++i) {
            if (this.LANGUAGES[i].iso === lang) {
                return this.LANGUAGES[i];
            }
        }
        return this.LANGUAGES[2];
    };
    SettingsService.prototype.getLanguage = function (lang) {
        for (var i = 0; i < this.LANGUAGES.length; ++i) {
            if (this.LANGUAGES[i].iso === lang) {
                return this.LANGUAGES[i];
            }
        }
        return null;
    };
    SettingsService.prototype.getLanguageIndex = function (lang) {
        for (var i = 0; i < this.LANGUAGES.length; ++i) {
            if (this.LANGUAGES[i].iso === lang) {
                return i;
            }
        }
        return 0;
    };
    return SettingsService;
}());
SettingsService = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [angular_l10n_1.TranslationService])
], SettingsService);
exports.SettingsService = SettingsService;
//# sourceMappingURL=settings.service.js.map