import { Component, OnInit, ElementRef } from "@angular/core";
import { Router } from "@angular/router";
import { Translation, LocaleService, TranslationService } from "angular-l10n";
import { ChsService } from "../chs.service";
import { AuthService } from "../auth.service";
import { md5 } from "../md5";

@Component({
	moduleId: module.id,
	templateUrl: "login.component.html"
})
export class LoginComponent   {
	private _password: string;
	private _loginFailed: boolean;
	constructor(public translation: TranslationService,
		private el: ElementRef, private _chsService: ChsService, private _authService: AuthService, private _router: Router) {
		 
	}

	onSubmit(): void {
		let strMd5=md5(this._password);
		if (this._authService.login(strMd5)) {
			this._router.navigate([this._authService.redirectUrl]);
		}	else {
			this._loginFailed=true;
		}
	}
}