"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
exports.MAX_VALUE_VALIDATOR = {
    provide: forms_1.NG_VALIDATORS,
    useExisting: core_1.forwardRef(function () { return MaxValueValidator; }),
    multi: true
};
var MaxValueValidator = MaxValueValidator_1 = (function () {
    function MaxValueValidator(mx) {
        if (mx !== undefined && mx !== null) {
            var attrValue = parseInt(mx, 10);
            if (!isNaN(attrValue)) {
                this.max = mx;
                this._createValidator();
            }
        }
    }
    MaxValueValidator.prototype.ngOnChanges = function (changes) {
        var maxChange = changes["max"];
        if (maxChange) {
            this._createValidator();
        }
    };
    MaxValueValidator.prototype._createValidator = function () {
        this._validator = MaxValueValidator_1.max(parseInt(this.max, 10));
    };
    MaxValueValidator.prototype.validate = function (c) { return this._validator(c); };
    MaxValueValidator.max = function (mx) {
        return function (control) {
            var v = +control.value;
            return (v > mx ? { "max": { "maxValue": mx, "actualValue": v } } : null);
        };
    };
    return MaxValueValidator;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], MaxValueValidator.prototype, "max", void 0);
MaxValueValidator = MaxValueValidator_1 = __decorate([
    core_1.Directive({
        selector: "[max][formControlName],[min][formControl],[min][ngModel]",
        providers: [exports.MAX_VALUE_VALIDATOR],
        host: { "[attr.max]": "max ? max : 0" }
    }),
    __param(0, core_1.Attribute("max")),
    __metadata("design:paramtypes", [String])
], MaxValueValidator);
exports.MaxValueValidator = MaxValueValidator;
var MaxValueValidator_1;
//# sourceMappingURL=max-value-validator.directive.js.map