"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
exports.MIN_VALUE_VALIDATOR = {
    provide: forms_1.NG_VALIDATORS,
    useExisting: core_1.forwardRef(function () { return MinValueValidator; }),
    multi: true
};
var MinValueValidator = MinValueValidator_1 = (function () {
    function MinValueValidator(mn) {
        if (mn !== undefined && mn !== null) {
            var attrValue = parseInt(mn, 10);
            if (!isNaN(attrValue)) {
                this.min = mn;
                this._createValidator();
            }
        }
    }
    MinValueValidator.prototype.ngOnChanges = function (changes) {
        var minChange = changes["min"];
        if (minChange) {
            this._createValidator();
        }
    };
    MinValueValidator.prototype._createValidator = function () {
        this._validator = MinValueValidator_1.min(parseInt(this.min, 10));
    };
    MinValueValidator.prototype.validate = function (c) { return this._validator(c); };
    MinValueValidator.min = function (mn) {
        return function (control) {
            var v = +control.value;
            return (v < mn ? { "min": { "minValue": mn, "actualValue": v } } : null);
        };
    };
    return MinValueValidator;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], MinValueValidator.prototype, "min", void 0);
MinValueValidator = MinValueValidator_1 = __decorate([
    core_1.Directive({
        selector: "[min][formControlName],[min][formControl],[min][ngModel]",
        providers: [exports.MIN_VALUE_VALIDATOR],
        host: { "[attr.min]": "min ? min : 0" }
    }),
    __param(0, core_1.Attribute("min")),
    __metadata("design:paramtypes", [String])
], MinValueValidator);
exports.MinValueValidator = MinValueValidator;
var MinValueValidator_1;
//# sourceMappingURL=min-value-validator.directive.js.map