import { NgModule } from "@angular/core";
import { CommonModule } from "@angular/common";
import { FormsModule, ReactiveFormsModule } from "@angular/forms";
import { TranslationModule } from "angular-l10n";
import { SpinnerComponent } from "./spinner.component";
import { LoginComponent } from "./login.component";
import { MinValueValidator } from "./min-value-validator.directive";
import { MaxValueValidator } from "./max-value-validator.directive";

@NgModule({
  imports: [
    TranslationModule.forChild(),
    CommonModule, FormsModule, ReactiveFormsModule],
  declarations: [
    SpinnerComponent, LoginComponent, MinValueValidator, MaxValueValidator
  ],
  exports: [SpinnerComponent, LoginComponent]
})
export class SharedModule { }