import { Component, Input, OnDestroy } from '@angular/core';
import { Observable } from 'rxjs/Observable';
import { Observer } from 'rxjs/Observer';
import { Subscription } from 'rxjs/Subscription';
import 'rxjs/add/operator/delay';
import 'rxjs/add/observable/empty';

@Component({
	moduleId: module.id,
	selector: 'nice-spinner',
	templateUrl: 'spinner.component.html',
		styleUrls: ['spinner.component.css']
})
export class SpinnerComponent implements OnDestroy {
	private _isRunning: boolean = false;
		private _subscriptionDelay: Subscription;

	@Input()
	public delay: number = 300;

	@Input()
	public set isRunning(value: boolean) {
		if (!value) {
			this.cancelTimeout();
			this._isRunning = false;
			return;
		}

		if (this._isRunning) return;

		if (this.delay > 0) {
			this._subscriptionDelay=Observable.empty().delay(this.delay).subscribe(x => {}, err => {}, () => { 
				console.debug('delay vorbei');
				this._isRunning=true; 
			});
		}
		else
			this._isRunning=true;
	}

	private cancelTimeout(): void {
		if (this._subscriptionDelay) {
			this._subscriptionDelay.unsubscribe();
			this._subscriptionDelay = undefined;
		}
	}

	ngOnDestroy(): any {
		this.cancelTimeout();
	}
}