"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var angular_l10n_1 = require("angular-l10n");
var chs_service_1 = require("../chs.service");
var moment = require("moment");
var TimerdisplayComponent = TimerdisplayComponent_1 = (function () {
    function TimerdisplayComponent(translation, el, _chsService) {
        this.translation = translation;
        this.el = el;
        this._chsService = _chsService;
    }
    TimerdisplayComponent.prototype.ngOnInit = function () {
        this._timerDaysDescr = this.daysToString(this.timer.days);
        this._timerTypeDescr = this.timerTypeDescr();
        this._timerDetailsDescr = this.timerDetailsDescr();
        this._timerTarget = this.timerTarget();
    };
    TimerdisplayComponent.prototype.TimeToString = function (tm) {
        var fmt = "HH:mm";
        var ret = new Date(1970, 1, 1, 12, 0, 0);
        if (!tm) {
            return moment(ret).format(fmt);
        }
        var splitted = tm.split(":");
        if (splitted.length !== 2) {
            return moment(ret).format(fmt);
        }
        return moment(new Date(1970, 1, 1, parseInt(splitted[0]), parseInt(splitted[1]), 0)).format(fmt);
    };
    TimerdisplayComponent.prototype.t = function (str) {
        return this.translation.translate(str);
    };
    TimerdisplayComponent.prototype.timerTypeDescr = function () {
        if (!this.timer) {
            return "null";
        }
        var ret = this.t(TimerdisplayComponent_1._type[this.timer.timer_type]);
        switch (this.timer.timer_type) {
            case "static":
                ret += ": " + this.TimeToString(this.timer.time);
                break;
            case "random":
                ret += ": " + this.TimeToString(this.timer.time);
                break;
            case "astroSunrise":
                if (this.timer.time) {
                    ret += " " + this.t("NOTBEFORE") + " " + this.TimeToString(this.timer.time);
                    if (this.timer.offset) {
                        ret += ", " + this.t("ASTROOFFSET") + " " + this.timer.offset.toString() + " " + this.t("MINUTES");
                    }
                }
                break;
            case "astroSunset":
                if (this.timer.time) {
                    ret += " " + this.t("NOTAFTER") + " " + this.TimeToString(this.timer.time);
                    if (this.timer.offset) {
                        ret += ", " + this.t("ASTROOFFSET") + " " + this.timer.offset.toString() + " " + this.t("MINUTES");
                    }
                }
                break;
        }
        return ret;
    };
    TimerdisplayComponent.prototype.timerDetailsDescr = function () {
        if (!this.timer) {
            return "null";
        }
        var ret = "";
        if (this.timer.readings) {
            var next = this.timer.readings["next"];
            if (next) {
                ret += this.t("NEXTSWITCHTIME") + " " + moment(next).format("HH:mm DD.MM.YYYY");
            }
        }
        return ret;
    };
    TimerdisplayComponent.prototype.timerTarget = function () {
        if (!this.timer) {
            return "null";
        }
        var ret = "";
        if (this.devType === "slider" || this.devType === "onoff") {
            switch (this.timer.device_state) {
                case "on":
                    ret += this.t("SWITCHON");
                    break;
                case "off":
                    ret += this.t("SWITCHOFF");
                    break;
                case "driveUp":
                    ret += this.t("DRIVETO") + " " + this.t("POSUP");
                    break;
                case "driveDown":
                    ret += this.t("DRIVETO") + " " + this.t("POSDOWN");
                    break;
                case "drivePos1":
                    ret += this.t("DRIVETO") + " " + this.t("POSINT");
                    break;
                case "drivePos2":
                    ret += this.t("DRIVETO") + " " + this.t("POSAIR");
                    break;
                default:
                    if (this.timer.device_state.startsWith("drivePos ")) {
                        ret += this.t("DRIVETO") + " " + this.timer.device_state.substring(9) + "%";
                    }
            }
        }
        return ret;
    };
    TimerdisplayComponent.prototype.daysToString = function (days) {
        if (!days || days.length !== 7) {
            return;
        }
        var retVal = "";
        var i = 0;
        while (i < 7) {
            if (days[i] === "1") {
                retVal += this.t(TimerdisplayComponent_1._days[i]) + ", ";
            }
            ++i;
        }
        if (retVal.length > 2) {
            retVal = retVal.substr(0, retVal.length - 2);
        }
        return retVal;
    };
    TimerdisplayComponent.prototype.saveTimer = function () {
        this._chsService.writeDevice(this.timer).subscribe();
    };
    TimerdisplayComponent.prototype.onSwitchChange = function (val) {
        this.timer.state = (val.args.checked ? "on" : "off");
        this.saveTimer();
    };
    return TimerdisplayComponent;
}());
TimerdisplayComponent._type = {
    "static": "TIMERTINDIVIDUAL", "random": "TIMERTRANDOM",
    "astroSunrise": "TIMERTASTROM", "astroSunset": "TIMERTASTROE"
};
TimerdisplayComponent._days = ["SUNABBR", "MONABBR", "TUEABBR", "WEDABBR", "THUABBR", "FRIABBR", "SATABBR"];
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], TimerdisplayComponent.prototype, "timer", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], TimerdisplayComponent.prototype, "devType", void 0);
TimerdisplayComponent = TimerdisplayComponent_1 = __decorate([
    core_1.Component({
        moduleId: module.id,
        selector: "timer-display",
        template: "\n\t\t<div>\n\t\t\t<jqxSwitchButton style='float: right; margin-right: -5px; margin-top: -5px;'\n\t\t\t\t[height]='24' [onLabel]='translation.translate(\"ON\")' [offLabel]='translation.translate(\"OFF\")' (onChange)=\"onSwitchChange($event)\"\n\t\t\t\t[checked]=\"timer.state=='on'\"></jqxSwitchButton>\n\t\t\n\t\t\t<div>{{ _timerTypeDescr }}</div>\n\t\t\t<div>{{ _timerDaysDescr }}</div>\n\t\t\t<div *ngIf=\"devType=='onoff' || devType=='slider'\">\n\t\t\t\t{{ _timerTarget }}\n\t\t\t</div>\n\t\t\t<div>{{ _timerDetailsDescr }}</div>\n\t\t</div>\n\t"
    }),
    __metadata("design:paramtypes", [angular_l10n_1.TranslationService, core_1.ElementRef, chs_service_1.ChsService])
], TimerdisplayComponent);
exports.TimerdisplayComponent = TimerdisplayComponent;
var TimerdisplayComponent_1;
//# sourceMappingURL=timer.display.component.js.map