"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@angular/core");
var angular_l10n_1 = require("angular-l10n");
var moment = require("moment");
var chs_service_1 = require("../chs.service");
var utils_1 = require("../utils");
var TypeToIndexPipe = TypeToIndexPipe_1 = (function () {
    function TypeToIndexPipe() {
    }
    TypeToIndexPipe.prototype.transform = function (value) {
        return TypeToIndexPipe_1._TypeToIndex[value];
    };
    return TypeToIndexPipe;
}());
TypeToIndexPipe._TypeToIndex = { "static": 0, "random": 1, "astroSunrise": 2, "astroSunset": 3 };
TypeToIndexPipe = TypeToIndexPipe_1 = __decorate([
    core_2.Pipe({ name: "TypeToIndex" })
], TypeToIndexPipe);
exports.TypeToIndexPipe = TypeToIndexPipe;
var TargetToIndexPipe = TargetToIndexPipe_1 = (function () {
    function TargetToIndexPipe() {
    }
    TargetToIndexPipe.prototype.transform = function (value) {
        return TargetToIndexPipe_1._TargetToIndex[value];
    };
    return TargetToIndexPipe;
}());
TargetToIndexPipe._TargetToIndex = { "driveUp": 0, "drivePos2": 1, "drivePos1": 2, "driveDown": 3, "drivePos ": 4 };
TargetToIndexPipe = TargetToIndexPipe_1 = __decorate([
    core_2.Pipe({ name: "TargetToIndex" })
], TargetToIndexPipe);
exports.TargetToIndexPipe = TargetToIndexPipe;
var TimeToDatePipe = (function () {
    function TimeToDatePipe() {
    }
    TimeToDatePipe.prototype.transform = function (value) {
        if (!value) {
            return new Date(1970, 1, 1, 12, 0, 0);
        }
        var splitted = value.split(":");
        if (splitted.length !== 2) {
            return new Date(1970, 1, 1, 12, 0, 0);
        }
        return new Date(1970, 1, 1, parseInt(splitted[0], 10), parseInt(splitted[1], 10), 0);
    };
    return TimeToDatePipe;
}());
TimeToDatePipe = __decorate([
    core_2.Pipe({ name: "TimeToDate" })
], TimeToDatePipe);
exports.TimeToDatePipe = TimeToDatePipe;
var TimereditorComponent = TimereditorComponent_1 = (function () {
    function TimereditorComponent(translation, _chsService) {
        this.translation = translation;
        this._chsService = _chsService;
        this.onDeleted = new core_1.EventEmitter();
        this._dropDownTypeSource = ["individuell", "Zufall", "Astro morgens", "Astro abends"];
        this._dropDownTargetSource = [{ label: "", target: "driveUp" }, { label: "", target: "drivePos2" },
            { label: "", target: "drivePos1" }, { label: "", target: "driveDown" }, { label: "", target: "drivePos " }];
    }
    TimereditorComponent.prototype.onClose = function () {
        this.onDeleted.emit(this.timer.id);
    };
    TimereditorComponent.prototype.setDays = function (days) {
        this._sunday = (days[0] === "1");
        this._monday = (days[1] === "1");
        this._tuesday = (days[2] === "1");
        this._wednesday = (days[3] === "1");
        this._thursday = (days[4] === "1");
        this._friday = (days[5] === "1");
        this._saturday = (days[6] === "1");
    };
    TimereditorComponent.prototype.daysToArray = function (days) {
        if (!days || days.length !== 7) {
            return;
        }
        var retVal = [];
        var i = 0;
        while (i < 7) {
            if (days[i] === "1") {
                retVal.push(i);
            }
            ++i;
        }
        return retVal;
    };
    TimereditorComponent.prototype.ngOnInit = function () {
        if (this.timer.time == null) {
            this.timer.time = "12:00";
        }
        this._dropDownTypeSource[0] = this.translation.translate("TIMERTINDIVIDUAL");
        this._dropDownTypeSource[1] = this.translation.translate("TIMERTRANDOM");
        this._dropDownTypeSource[2] = this.translation.translate("TIMERTASTROM");
        this._dropDownTypeSource[3] = this.translation.translate("TIMERTASTROE");
        //this._dropDownTypeSource.placeHolder=this.translation.translate("CHOOSETIMERT");
        var dtTargets = this._dropDownTargetSource;
        dtTargets[0].label = this.translation.translate("POSUP");
        dtTargets[1].label = this.translation.translate("POSAIR");
        dtTargets[2].label = this.translation.translate("POSINT");
        dtTargets[3].label = this.translation.translate("POSDOWN");
        dtTargets[4].label = this.translation.translate("POSIND");
        if (this.devType === "slider") {
            this._targetPos = 50;
            this._targetState = this.timer.device_state;
            if (this._targetState.startsWith("drivePos ")) {
                // this._targetPos=Number.parseInt(this._targetState.substring(8));
                this._targetPos = Number(this._targetState.substring(9));
                this._targetState = this._targetState.substring(0, 9);
            }
        }
        else if (this.devType === "onoff") {
            this._targetState = this.timer.device_state;
        }
        this.setDays(this.timer.days);
    };
    TimereditorComponent.prototype.onDayChange = function (event) {
        var name = event.target.name;
        var checked = event.target["checked"] ? "1" : "0";
        var index = -1;
        switch (name) {
            case "_sunday":
                index = 0;
                break;
            case "_monday":
                index = 1;
                break;
            case "_tuesday":
                index = 2;
                break;
            case "_wednesday":
                index = 3;
                break;
            case "_thursday":
                index = 4;
                break;
            case "_friday":
                index = 5;
                break;
            case "_saturday":
                index = 6;
                break;
        }
        this.timer.days = utils_1.strSetChar(this.timer.days, index, checked);
        this.saveTimer();
    };
    TimereditorComponent.prototype.onNotBeforeAfterChange = function (event) {
        var checked = event.target["checked"];
        if (!checked) {
            this.timer.time = null;
        }
        else {
            this.timer.time = "12:00";
        }
        this.saveTimer();
    };
    TimereditorComponent.prototype.onTimeChange = function (event) {
        var d = event.args.date;
        var m = moment(d).utc().local();
        var strTime = m.format("HH:mm");
        if (this.timer.time !== strTime) {
            this.timer.time = strTime;
            this.saveTimer();
        }
    };
    TimereditorComponent.prototype.onTypeChanged = function (event) {
        var index = event.args.index;
        this.timer.timer_type = TimereditorComponent_1._IndexToType[index];
        this.saveTimer();
    };
    TimereditorComponent.prototype.onSwitchChange = function (val) {
        var strNewVal = (val.args.checked ? "on" : "off");
        if (this.timer.state !== strNewVal) {
            this.timer.state = strNewVal;
            this.saveTimer();
        }
    };
    TimereditorComponent.prototype.onOffsetChange = function (event) {
        var val = event.args.value;
        var num = Math.round(val);
        if (this.timer.offset !== num) {
            this.timer.offset = num;
            this.saveTimer();
        }
    };
    TimereditorComponent.prototype.saveTimer = function () {
        this._chsService.writeDevice(this.timer).subscribe();
    };
    TimereditorComponent.prototype.onTargetPosChanged = function (args) {
        var pos = args.value;
        if (pos !== this._targetPos) {
            this._targetPos = pos;
            this.timer.device_state = "drivePos " + this._targetPos.toString();
            this.saveTimer();
        }
    };
    TimereditorComponent.prototype.onChangeTarget = function (event) {
        //let index: number = event.args.index;
        //this._targetState = this._dropDownTargetSource[index].target;
        this._targetState = event;
        this.timer.device_state = this._targetState;
        if (this._targetState === "drivePos ") {
            this.timer.device_state = "drivePos " + this._targetPos.toString();
        }
        this.saveTimer();
    };
    return TimereditorComponent;
}());
TimereditorComponent._IndexToType = { 0: "static", 1: "random", 2: "astroSunrise", 3: "astroSunset" };
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], TimereditorComponent.prototype, "timer", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], TimereditorComponent.prototype, "devType", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", Object)
], TimereditorComponent.prototype, "onDeleted", void 0);
__decorate([
    angular_l10n_1.Language(),
    __metadata("design:type", String)
], TimereditorComponent.prototype, "lang", void 0);
TimereditorComponent = TimereditorComponent_1 = __decorate([
    core_1.Component({
        moduleId: module.id,
        selector: "timer-editor",
        templateUrl: "timereditor.component.html"
    }),
    __metadata("design:paramtypes", [angular_l10n_1.TranslationService, chs_service_1.ChsService])
], TimereditorComponent);
exports.TimereditorComponent = TimereditorComponent;
var TypeToIndexPipe_1, TargetToIndexPipe_1, TimereditorComponent_1;
//# sourceMappingURL=timereditor.component.js.map