"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var chs_service_1 = require("../chs.service");
var TimersComponent = (function () {
    function TimersComponent(_chsService, _route, _router) {
        this._chsService = _chsService;
        this._route = _route;
        this._router = _router;
        this._timers = [];
        this._deviceid = this._route.snapshot.params["id"].replace("__", ".");
    }
    TimersComponent.prototype.ngOnInit = function () {
        var _this = this;
        var comp = this;
        this._chsService.getDevices().subscribe(function (devs) {
            try {
                comp._device = comp._chsService.getCachedDev(comp._deviceid);
                comp._timers = [];
                comp._chsService.Timers.forEach(function (dev) { if (dev.type == "timer" && dev.device == comp._deviceid)
                    comp._timers.push(dev); });
                if (_this._device.type == "group")
                    comp._devType = _this._chsService.getDeviceState(_this._device.id);
            }
            catch (ex) {
            }
        }, function (error) { });
    };
    TimersComponent.prototype.onNewTimer = function () {
        var _this = this;
        this._chsService.newTimer(this._deviceid).subscribe(function (timer) {
            _this._timers.push(timer);
        });
    };
    TimersComponent.prototype.onTimerDelete = function (id) {
        var _this = this;
        this._chsService.deleteTimer(id).subscribe(function () {
            _this._timers = _this._timers.filter(function (s) { return s.id != id; });
        });
    };
    TimersComponent.prototype.onBack = function () {
        if (this._device.type == "scene")
            this._router.navigate(["/cfg/scenes"]);
        else
            this._router.navigate(["/cfg/groups"]);
    };
    return TimersComponent;
}());
TimersComponent = __decorate([
    core_1.Component({
        template: "\n\t\t\t<div class='panel panel-primary'>\n\t\t\t\t<div class='panel-heading'><span translate>SWITCHTIMESFOR</span> {{_device?.name}}</div>\n\t\t\t\t<div class='panel-body'>\n\t\t\t\t\t<div *ngFor=\"let timer of _timers\" class='panel panel-default'>\n\t\t\t\t\t\t<timer-editor [timer]=\"timer\" [devType]=\"_devType\" (onDeleted)=\"onTimerDelete($event)\"></timer-editor>\n\t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t\t<br />\n\t\t\t<button type=\"button\" class=\"btn btn-default btn-sm\" (click)=\"onNewTimer()\" translate>NEWSWITCHTIME</button>\n\t\t\t<button type=\"button\" class=\"btn btn-default btn-sm\" (click)=\"onBack()\" translate>BACK</button>\n\t\t\t"
    }),
    __metadata("design:paramtypes", [chs_service_1.ChsService, router_1.ActivatedRoute, router_1.Router])
], TimersComponent);
exports.TimersComponent = TimersComponent;
//# sourceMappingURL=timers.component.js.map