import { NgModule } from "@angular/core";
import { CommonModule } from "@angular/common";
import { FormsModule } from "@angular/forms";
import { JqwidgetsModule } from "../jqwidgets-ts/jqwidgets.module";
import { TranslationModule } from "angular-l10n";
import { TimersComponent } from "./timers.component";
import { TimereditorComponent, TypeToIndexPipe, TargetToIndexPipe, TimeToDatePipe } from "./timereditor.component";
import { TimerdisplayComponent } from "./timer.display.component";
import { timersRouting } from "./timers.routing";
import { SharedModule } from "../shared/shared.module";

@NgModule({
  imports: [
    TranslationModule.forChild(),
    CommonModule, JqwidgetsModule, FormsModule, SharedModule, timersRouting],
  declarations: [
    TimersComponent, TimereditorComponent, TimerdisplayComponent,
    TypeToIndexPipe, TargetToIndexPipe, TimeToDatePipe
  ],
  exports: [TimerdisplayComponent, TypeToIndexPipe, TargetToIndexPipe, TimeToDatePipe]
})
export class TimersModule { }