import { Injectable } from "@angular/core";
import { Translation, TranslationService } from "angular-l10n";
import { resources } from "./utils";

@Injectable()
export class TranslateService   {
	constructor(public translation: TranslationService) {
		 
		this.translateResources();
		this.translation.translationChanged.subscribe(() => {
			this.translateResources();
		});
	}

	public translateResources(): void {
		resources.forEach(res => {
			res.name = this.translation.translate(res.id.toUpperCase());
		});
	}
}