"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var chs_service_1 = require("../chs.service");
require("bootstrap");
var UpdateComponent = (function () {
    function UpdateComponent(_chsService, _router) {
        this._chsService = _chsService;
        this._router = _router;
        this.version = { version: "", server: "", update: false };
        this._updating = false;
        this._subPoll = null;
    }
    UpdateComponent.prototype.getVersion = function () {
        var _this = this;
        this._chsService.getVersion().subscribe(function (ver) { return _this.version = ver; });
    };
    UpdateComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (!this._chsService.GotVersionInfo) {
            this.getVersion();
        }
        else {
            this.version = this._chsService.VersionInfo;
        }
        this._chsService.onError.subscribe(function (res) { _this.onChsServiceError(res); });
    };
    UpdateComponent.prototype.ngOnDestroy = function () {
        if (this._subPoll) {
            this._subPoll.unsubscribe();
        }
    };
    UpdateComponent.prototype.onChsServiceError = function (res) {
        if (res.status === 0) {
            this._chsService.showMessageBox("Server nicht erreichbar");
        }
        else {
            this._chsService.showMessageBox("Server-Fehler: (" + res.status + ") " + res.statusText);
        }
    };
    UpdateComponent.prototype.onUpdate = function () {
        this._chsService.startUpdate().subscribe();
        this._updating = true;
        this._chsService.pollServerVersion(function () { window.location.href = "/"; });
    };
    return UpdateComponent;
}());
UpdateComponent = __decorate([
    core_1.Component({
        moduleId: module.id,
        templateUrl: "update.component.html"
    }),
    __metadata("design:paramtypes", [chs_service_1.ChsService, router_1.Router])
], UpdateComponent);
exports.UpdateComponent = UpdateComponent;
//# sourceMappingURL=update.component.js.map