"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.global_theme = "web";
exports.backcolor = "#69AC13";
//export const language: string = "language";
function getSettings(elem) {
    var attrSettings = elem.attr("jqx-settings");
    var objSettings = {};
    if (attrSettings)
        objSettings = JSON.parse(attrSettings);
    if (!objSettings.theme)
        objSettings.theme = exports.global_theme;
    return objSettings;
}
exports.getSettings = getSettings;
function sortDevs(devs) {
    var ar = Array();
    var i = devs.next();
    while (!i.done) {
        ar.push(i.value);
        i = devs.next();
    }
    ar = ar.sort(function (a, b) {
        if (a.sort != undefined && b.sort != undefined)
            return a.sort - b.sort;
        return a.name.localeCompare(b.name);
    });
    return ar;
}
exports.sortDevs = sortDevs;
function sortRealDevs(devs) {
    var ar = Array();
    var i = devs.next();
    while (!i.done) {
        ar.push(i.value);
        i = devs.next();
    }
    ar = ar.sort(function (a, b) {
        if (a.sort_dev != undefined && b.sort_dev != undefined)
            return a.sort_dev - b.sort_dev;
        return a.name.localeCompare(b.name);
    });
    return ar;
}
exports.sortRealDevs = sortRealDevs;
function maxSort(map) {
    var maxSort = -1;
    map.forEach(function (dev) {
        if (dev.sort != undefined && dev.sort > maxSort)
            maxSort = dev.sort;
    });
    return maxSort;
}
exports.maxSort = maxSort;
function maxSortRealDev(map) {
    var maxSort = -1;
    map.forEach(function (dev) {
        if (dev.sort_dev != undefined && dev.sort_dev > maxSort)
            maxSort = dev.sort_dev;
    });
    return maxSort;
}
exports.maxSortRealDev = maxSortRealDev;
function strSetChar(str, index, c) {
    var retVal = '';
    if (index >= str.length)
        return str + c;
    if (index > 0)
        retVal = str.substring(0, index);
    retVal += c;
    retVal += str.substring(index + 1);
    return retVal;
}
exports.strSetChar = strSetChar;
function getSortedColumnItems(kanban, col) {
    var items = kanban.getColumnItems(col);
    var retItems = [];
    var itemsInOrder = jQuery('[data-kanban-column-container="' + col + '"] .jqx-kanban-item .jqx-kanban-item-text', kanban.host);
    for (var i = 0; i < itemsInOrder.length; ++i) {
        var strItem = jQuery(itemsInOrder[i]).text();
        for (var k = 0; k < items.length; ++k) {
            if ((items[k].text) === strItem) {
                retItems.push(items[k]);
                // console.debug(items[k]);
            }
        }
    }
    return retItems;
}
exports.getSortedColumnItems = getSortedColumnItems;
exports.resources = [
    { id: "light", name: "Licht", image: "../../images/bulb.png" },
    { id: "switch", name: "Schalter", image: "../../images/switch.png" },
    { id: "night-switch", name: "Nachtschalter", image: "../../images/switch.png" },
    { id: "dimmer", name: "Dimmer", image: "../../images/dimmer.png" },
    { id: "shutter", name: "Rolllade", image: "../../images/shutter.png" },
    { id: "marquee", name: "Markise", image: "../../images/marquee.png" },
    { id: "jalousie", name: "Jalousie", image: "../../images/jalousie.png" },
    { id: "scene", name: "Szene", image: "../../images/scene.png" },
    { id: "group", name: "Gruppe", image: "../../images/group.png" }
];
//# sourceMappingURL=utils.js.map