import { ElementRef, Renderer2 } from '@angular/core';
import { LocaleService } from '../services/locale.service';
import { BaseDirective } from '../models/base-directive';
export declare class LocaleDecimalDirective extends BaseDirective {
    protected locale: LocaleService;
    protected el: ElementRef;
    protected renderer: Renderer2;
    l10nDecimal: string;
    localeDecimal: string;
    private digits;
    private localeDecimalPipe;
    constructor(locale: LocaleService, el: ElementRef, renderer: Renderer2);
    protected setup(): void;
    protected replace(): void;
    protected replaceText(): void;
    protected replaceAttributes(): void;
    protected getValues(keys: string | string[]): string | any;
}
export declare class LocalePercentDirective extends BaseDirective {
    protected locale: LocaleService;
    protected el: ElementRef;
    protected renderer: Renderer2;
    l10nPercent: string;
    localePercent: string;
    private digits;
    private localePercentPipe;
    constructor(locale: LocaleService, el: ElementRef, renderer: Renderer2);
    protected setup(): void;
    protected replace(): void;
    protected replaceText(): void;
    protected replaceAttributes(): void;
    protected getValues(keys: string | string[]): string | any;
}
export declare class LocaleCurrencyDirective extends BaseDirective {
    protected locale: LocaleService;
    protected el: ElementRef;
    protected renderer: Renderer2;
    l10nCurrency: string;
    localeCurrency: string;
    symbol: boolean;
    private digits;
    private localeCurrencyPipe;
    constructor(locale: LocaleService, el: ElementRef, renderer: Renderer2);
    protected setup(): void;
    protected replace(): void;
    protected replaceText(): void;
    protected replaceAttributes(): void;
    protected getValues(keys: string | string[]): string | any;
}
