/// <reference_path path="../jquery/jquery.d.ts" />

interface DataField {
	name: string,
	type: string,
	format?: string,
	map?: string,
}

interface DataSource {
	url: string,
	timeout: number,
	data: Object,
	datatype: string,
	localdata: Object,
	type: string,
	id: string,
	root: string,
	record: string,
	datafields: DataField[],
	mapChar?: string,
	columnDelimiter?: string,
	rowDelimiter? :string,
	values: Object
}

interface DataAdapter {
	new (source: any): DataAdapter;
	records: any[];
}

interface Jqx {
	dataAdapter: DataAdapter; 
}

interface JqWidgets {
}

interface JQueryStatic {
	jqx: Jqx;
}

interface JQuery {
	jqxKanban(verb: string, param: string): any;
	jqxKanban(verb: 'getColumnItems', col: string): any[];
	jqxKanban(verb: 'getItems'): any[];
	jqxKanban(obj: any): JQuery;
	jqxKanban(verb: string, obj: any): JQuery;
	jqxKanban(verb: string, id: string, obj: any): JQuery;
	jqxSlider(settings: Object): JQuery;
	jqxSlider(verb: string): JQuery;
	jqxSlider(verb: string, val: string | number | boolean): JQuery;
	jqxMenu(obj: Object): JQuery;
	jqxMenu(verb: string): JQuery;
	jqxMenu(verb: string): JQuery;
	jqxMenu(verb: string, arg1: any, arg2:any): JQuery;
	jqxSortable(): void;
	jqxSortable(verb: string): any;
	jqxSortable(settings: Object): any;
	jqxExpander(): void;
	jqxExpander(settings: Object): any;
	jqxButtonGroup(): void;
	jqxButtonGroup(settings: Object): any;
	jqxButton(): void;
	jqxButton(settings: Object): any;
	jqxSwitchButton(): void;
	jqxSwitchButton(settings: Object): any;
	jqxRadioButton(): void;
	jqxRadioButton(settings: Object): any;
	jqxCheckBox(): void;
	jqxCheckBox(verb: string): any;
	jqxCheckBox(verb: string, value: string): any;
	jqxCheckBox(settings: Object): any;
	jqxRadioButton(settings: Object): any;
	jqxNotification(): void;
	jqxNotification(settings: Object): any;
	jqxInput(): void;
	jqxInput(verb: string, value: string | number): any;
	jqxInput(settings: Object): any;
	jqxDropDownList(): void;
	jqxDropDownList(verb: string, value: string | number): any;
	jqxDropDownList(settings: Object): any;
	jqxDateTimeInput(settings: any): any;
	jqxDateTimeInput(verb: string): any;
	jqxDateTimeInput(verb: string, value: any): any;
	jqxMaskedInput(settings: Object): any;
	jqxMaskedInput(verb: "clear"): any;
	jqxMaskedInput(verb: "focus"): any;
	jqxMaskedInput(verb: "val"): string | number;
	jqxMaskedInput(verb: "val", value: string | number): any;
	jqxNumberInput(settings: Object): any;
	jqxNumberInput(verb: "clear"): any;
	jqxNumberInput(verb: "focus"): any;
	jqxNumberInput(verb: "val", value: string): any;
	jqxNumberInput(verb: "val"): string;
	jqxNumberInput(verb: "setDecimal", value: number): any;
	jqxNumberInput(verb: "getDecimal"): number;
}